<?php  
            require('/srv2/pegasus.isi.edu/includes/common.php'); 
            pegasus_header("7.4. Amazon AWS Batch");
        ?><div class="breadcrumbs">
<span class="breadcrumb-link"><a href="index.php">Pegasus 4.9.3 User Guide</a></span> &gt; <span class="breadcrumb-link"><a href="execution_environments.php">Execution Environments</a></span> &gt; <span class="breadcrumb-node">Amazon AWS Batch</span>
</div><hr><div class="section">
<div class="titlepage"><div><div><h2 class="title" style="clear: both">
<a name="aws-batch"></a>7.4. Amazon AWS Batch</h2></div></div></div>
<div class="toc"><dl class="toc">
<dt><span class="section"><a href="aws-batch.php#aws-batch-setup">7.4.1. Setup</a></span></dt>
<dt><span class="section"><a href="aws-batch.php#idm3656">7.4.2. Creation of AWS Batch Entities for your Workflow</a></span></dt>
<dt><span class="section"><a href="aws-batch.php#idm3686">7.4.3. Site Catalog Entry for AWS Batch</a></span></dt>
<dt><span class="section"><a href="aws-batch.php#idm3691">7.4.4. Properties</a></span></dt>
</dl></div>
<p>Unlike the execution environments described in the previous section
    on Cloud where the user has to start condor workers on the cloud nodes,
    Amazon provides a managed service called AWS Batch. It automates the
    notion of provisioning nodes in the cloud, and setting up of a compute
    environment and a job queue that can submit jobs to those nodes.</p>
<p>Starting 4.9 release, Pegasus has support for executing horizontally
    clustered jobs on Amazon AWS Batch Service using the command line tool
    <a class="link" href="cli-pegasus-aws-batch.php" title="pegasus-aws-batch">pegasus-aws-batch</a>. In other
    words, you can get Pegasus to cluster each level of your workflow into a
    bag of tasks and run those clustered jobs on Amazon Cloud using AWS Batch
    Service. In upcoming releases, we plan to add support to pegasus-aws-batch
    to do dependency management that will allow us to execute the whole
    workflow in a single AWS Batch job.</p>
<div class="section">
<div class="titlepage"><div><div><h3 class="title">
<a name="aws-batch-setup"></a>7.4.1. Setup</h3></div></div></div>
<p>To use AWS Batch as user you need to do some one time setup to get
      started at running. Please follow the instructions carefully in this
      section.</p>
<div class="section">
<div class="titlepage"><div><div><h4 class="title">
<a name="idm3610"></a>7.4.1.1. Credentials</h4></div></div></div>
<p>To use AWS Batch for your workflows, we need two credential
        files</p>
<div class="orderedlist"><ol class="orderedlist" type="1">
<li class="listitem">
<p><span class="bold"><strong>AWS Credentials File:</strong></span> This
            is the file that you create and use whenever accessing Amazon EC2
            and is located at ~/.aws/credentials. For our purposes we need the
            following information in that file.</p>
<pre class="programlisting"><span class="bold"><strong>$ cat ~/.aws/credentials</strong></span>
[default]
aws_access_key_id = XXXXXXXXXXXX
aws_secret_access_key = XXXXXXXXXXX
</pre>
</li>
<li class="listitem">
<p><span class="bold"><strong>S3 Config File:</strong></span> Pegasus
            workflows use pegasus-s3 command line tool to stage-in input data
            required by the tasks to S3 and push data output data generated to
            S3 when user application code runs. These credentials are
            specified in .s3cfg file usually put in the user home directory.
            This format of the file is described in the <a class="link" href="cli-pegasus-s3.php" title="pegasus-s3">pegaus-s3 command line client's man
            page</a>. A minimalistic file is illustrated below</p>
<pre class="programlisting">$ <span class="bold"><strong>cat ~/.s3cfg
</strong></span>[amazon]
# end point has to be consistent with the EC2 region you are using. Here we are referring to us-west-2 region.
endpoint = http://s3-us-west-2.amazonaws.com


# Amazon now allows 5TB uploads
max_object_size = 5120
multipart_uploads = True
ranged_downloads = True


[user@amazon]
access_key = XXXXXXXXXXXX
secret_key = XXXXXXXXXXXX
</pre>
</li>
</ol></div>
</div>
<div class="section">
<div class="titlepage"><div><div><h4 class="title">
<a name="idm3625"></a>7.4.1.2. Setting up Container Image which your jobs run on</h4></div></div></div>
<p>All jobs in AWS Batch are run in a container via the Amazon EC2
        container service. The Amazon EC2 container service does not give
        control over the docker run command for a container. Hence, Pegasus
        runs jobs on container that is based on the <a class="ulink" href="https://aws.amazon.com/blogs/compute/creating-a-simple-fetch-and-run-aws-batch-job/" target="_top">Amazon
        Fetch and Run Example</a> . This container image allows us to
        fetch user executables automatically from S3. All container images
        referred used for Pegasus workflows must be based on the above
        example.</p>
<p>Additionally, the Docker file for your container image should
        include these additional Docker run commands to install the yum
        packages that Pegasus requires.</p>
<pre class="programlisting"><span class="bold"><strong>RUN yum -y install perl findutils</strong></span></pre>
<p>After you have pushed the Docker image to the Amazon ECR
        Repository, the image URL for that image you will use later to refer
        in the job definition to use for your jobs.</p>
</div>
<div class="section">
<div class="titlepage"><div><div><h4 class="title">
<a name="idm3633"></a>7.4.1.3. One time AWS Batch Setup</h4></div></div></div>
<p>If you are using AWS Batch for the very first time, then you
        need to use the Amazon Web console to create a role with your user
        that will give the AWS Batch services privileges to execute to access
        other AWS services such as EC2 Container Service , CloudWatchLogs etc.
        The following roles need to be created</p>
<div class="orderedlist"><ol class="orderedlist" type="1">
<li class="listitem"><p><span class="bold"><strong>AWS Batch Service IAM Role:</strong></span>
            For convenience and ease of use make sure you name the role
            <span class="bold"><strong>AWSBatchServiceRole</strong></span> , so that you
            don't have to make other changes. Complete the procedures listed
            at <a class="ulink" href="https://docs.aws.amazon.com/batch/latest/userguide/service_IAM_role.html" target="_top">AWS
            Batch Service IAM Role</a>.</p></li>
<li class="listitem"><p><span class="bold"><strong>Amazon ECS Instance Role:</strong></span>
            AWS Batch compute environments are populated with Amazon ECS
            container instances, and they run the Amazon ECS container agent
            locally. The Amazon ECS container agent makes calls to various AWS
            APIs on your behalf, so container instances that run the agent
            require an IAM policy and role for these services to know that the
            agent belongs to you. Complete the procedures listed at <a class="ulink" href="https://docs.aws.amazon.com/batch/latest/userguide/instance_IAM_role.html" target="_top">Amazon
            ECS Instance Role</a>.</p></li>
<li class="listitem">
<p><span class="bold"><strong>IAM Role:</strong></span> Whenever a
            Pegasus job runs via AWS Batch it needs to fetch data from S3 and
            push data back to S3. To create this job role follow the
            instructions at section <span class="emphasis"><em>Create an IAM role</em></span> in
            <a class="ulink" href="https://aws.amazon.com/blogs/compute/creating-a-simple-fetch-and-run-aws-batch-job/" target="_top">Amazon
            Fetch and Run Example</a> to create a IAM role named
            batchJobRole.</p>
<div class="note" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Note</h3>
<p>batchJobRole should have full write access to S3 i.e have
              the policy <span class="bold"><strong>AmazonS3FullAccess</strong></span>
              attached to it.</p>
</div>
</li>
</ol></div>
<div class="note" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Note</h3>
<p>It is important that you name the roles as listed above. Else,
          you will need to update the same job definition, compute
          environment, and job queue json files that you use to create the
          various Batch entities.</p>
</div>
</div>
</div>
<div class="section">
<div class="titlepage"><div><div><h3 class="title">
<a name="idm3656"></a>7.4.2. Creation of AWS Batch Entities for your Workflow</h3></div></div></div>
<p>AWS Batch has a notion of</p>
<div class="orderedlist"><ol class="orderedlist" type="1">
<li class="listitem"><p><span class="bold"><strong>Job Definition</strong></span> - job
          definition is something that allows you to use your container image
          in Amazon EC2 Repository to run one or many AWS Batch jobs.</p></li>
<li class="listitem"><p><span class="bold"><strong>Compute Environment </strong></span>- what
          sort of compute nodes you want your jobs to run on.</p></li>
<li class="listitem"><p><span class="bold"><strong>Job Queue</strong></span> - the queue that
          feeds the jobs to a compute environment.</p></li>
</ol></div>
<p>Currently, with Pegasus you can only use one of each for a
      workflow i.e the same job definition, compute environment and job queue
      need to be used for all jobs in the workflow.</p>
<p>To create the above entities we recommend you to use <span class="bold"><strong>pegasus-aws-batch </strong></span>client . You can start with the
      sample json files present in
      share/pegasus/examples/awsbatch-black-nonsharedfs directory.</p>
<div class="itemizedlist"><ul class="itemizedlist" style="list-style-type: disc; ">
<li class="listitem"><p><span class="bold"><strong>sample-job-definition.json :</strong></span>
          Edit the attribute named image and replace it with the ARN of the
          container image you built for your account</p></li>
<li class="listitem"><p><span class="bold"><strong>sample-compute-env.json</strong></span> :
          Edit the attributes subnets and securityGroupIds</p></li>
</ul></div>
<p>Before running the pegasus-aws-batch client make sure your
      properties file has the following properties</p>
<pre class="programlisting">pegasus.aws.region=  [amazon ec2 region]
pegasus.aws.account=[your aws account id - digits]</pre>
<p>You can then use pegasus-aws-batch client to generate the job
      definition, the compute environment and job queue to use.</p>
<pre class="programlisting"><span class="bold"><strong>$ pegasus-aws-batch --conf ./conf/pegasusrc --prefix pegasus-awsbatch-example --create --compute-environment ./conf/sample-compute-env.json --job-definition ./conf/sample-job-definition.json --job-queue ./conf/sample-job-queue.json 
</strong></span>

..

2018-01-18 15:16:00.771 INFO  [Synch] Created Job Definition
arn:aws:batch:us-west-2:405596411149:job-definition/pegasus-awsbatch-example-job-definition:1
2018-01-18 15:16:07.034 INFO  [Synch] Created Compute Environment
arn:aws:batch:us-west-2:XXXXXXXXXX:compute-environment/pegasus-awsbatch-example-compute-env
2018-01-18 15:16:11.291 INFO  [Synch] Created Job Queue
arn:aws:batch:us-west-2:XXXXXXXXXX:job-queue/pegasus-awsbatch-example-job-queue

2018-01-18 15:16:11.292 INFO  [PegasusAWSBatch] Time taken to execute
is 12.194 seconds</pre>
<p>You need to add the ARN's of created job definition, compute
      environment and job queue listed in pegasus-aws-batch output to your
      pegasusrc file</p>
<pre class="programlisting"># Properties required to run on AWS Batch

# the amazon region in which you are running workflows
pegasus.aws.region=us-west-2 

# your AWS account id ( in digits)
# pegasus.aws.account=XXXXXXXXXX

# ARN of the job definition that you create using pegasus-aws-batch
# pegasus.aws.batch.job_definition=arn:aws:batch:us-west-2:XXXXXXXXXX:job-definition/fetch_and_run

# ARN of the job definition that you create using pegasus-aws-batch
# pegasus.aws.batch.compute_environment=arn:aws:batch:us-west-2:XXXXXXXXXX:compute-environment/pegasus-awsbatch-example-compute-env

# ARN of the job queue that you create using pegasus-aws-batch
# pegasus.aws.batch.job_queue=arn:aws:batch:us-west-2:XXXXXXXXXX:job-queue/pegasus-awsbatch-example-job-queue
</pre>
</div>
<div class="section">
<div class="titlepage"><div><div><h3 class="title">
<a name="idm3686"></a>7.4.3. Site Catalog Entry for AWS Batch</h3></div></div></div>
<p>To run jobs on AWS Batch, you need to have an execution site in
      your site catalog. Here is a sample site catalog to use for running
      workflows on AWS Batch</p>
<pre class="programlisting">&lt;?xml version="1.0" encoding="UTF-8"?&gt;

&lt;sitecatalog xmlns="http://pegasus.isi.edu/schema/sitecatalog" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" 
                                              xsi:schemaLocation="http://pegasus.isi.edu/schema/sitecatalog 
                                                 http://pegasus.isi.edu/schema/sc-4.0.xsd" version="4.0"&gt;

  &lt;site  handle="local" arch="x86_64" os="LINUX" osrelease="" osversion="" glibc=""&gt;
        &lt;directory  path="/LOCAL/shared-scratch" type="shared-scratch" free-size="" total-size=""&gt;
                &lt;file-server  operation="all" url="file:///LOCAL/shared-scratch"&gt;
                &lt;/file-server&gt;
        &lt;/directory&gt;    
        &lt;directory  path="/LOCAL/shared-storage" type="shared-storage" free-size="" total-size=""&gt;
                &lt;file-server  operation="all" url="/LOCAL/shared-storage"&gt;
                &lt;/file-server&gt;
        &lt;/directory&gt;
        &lt;profile namespace="env" key="PEGASUS_HOME"&gt;/usr/bin/..&lt;/profile&gt; 
  &lt;/site&gt;

    &lt;site handle="aws-batch" arch="x86_64" os="LINUX"&gt;
        &lt;directory  path="pegasus-batch-bamboo"  type="shared-scratch" free-size="" total-size=""&gt;
                &lt;file-server  operation="all"  url="s3://user@amazon/pegasus-batch-bamboo"&gt;
                &lt;/file-server&gt;
        &lt;/directory&gt;

       &lt;profile namespace="pegasus" key="clusters.num"&gt;1&lt;/profile&gt;

       &lt;profile namespace="pegasus" key="style"&gt;condor&lt;/profile&gt;
      
       
   &lt;/site&gt;

&lt;/sitecatalog&gt;
</pre>
<p></p>
</div>
<div class="section">
<div class="titlepage"><div><div><h3 class="title">
<a name="idm3691"></a>7.4.4. Properties</h3></div></div></div>
<p>Once the whole setup is complete, before running a workflow make
      sure you have the following properties in your configuration file</p>
<pre class="programlisting"># get clustered jobs running  using AWSBatch
pegasus.clusterer.job.aggregator AWSBatch

#cluster even single jobs on a level
pegasus.clusterer.allow.single True


# Properties required to run on AWS Batch

# the amazon region in which you are running workflows
pegasus.aws.region=us-west-2 

# your AWS account id ( in digits)
# pegasus.aws.account=XXXXXXXXXX

# ARN of the job definition that you create using pegasus-aws-batch
pegasus.aws.batch.job_definition=pegasus-awsbatch-example-job-definition

# ARN of the job definition that you create using pegasus-aws-batch
pegasus.aws.batch.compute_environment=pegasus-awsbatch-example-compute-env

# ARN of the job queue that you create using pegasus-aws-batch
pegasus.aws.batch.job_queue=pegasus-awsbatch-example-job-queue


</pre>
</div>
</div><div class="navfooter">
<hr>
<table width="100%" summary="Navigation footer">
<tr>
<td width="40%" align="left">
<a accesskey="p" href="cloud.php">Prev</a> </td>
<td width="20%" align="center"><a accesskey="u" href="execution_environments.php">Up</a></td>
<td width="40%" align="right"> <a accesskey="n" href="pyglidein.php">Next</a>
</td>
</tr>
<tr>
<td width="40%" align="left" valign="top">7.3. Cloud (Amazon EC2/S3, Google Cloud, ...) </td>
<td width="20%" align="center"><a accesskey="h" href="index.php">Table of Contents</a></td>
<td width="40%" align="right" valign="top"> 7.5. Remote Cluster using PyGlidein</td>
</tr>
</table>
</div><?php  
            pegasus_footer();
        ?>
