<?php  
            require('/srv2/pegasus.isi.edu/includes/common.php'); 
            pegasus_header("pegasus-aws-batch");
        ?><div class="breadcrumbs">
<span class="breadcrumb-link"><a href="index.php">Pegasus 4.9.3 User Guide</a></span> &gt; <span class="breadcrumb-link"><a href="cli.php">Command Line Tools</a></span> &gt; <span class="breadcrumb-node">pegasus-aws-batch</span>
</div><hr><div lang="en" class="refentry">
<a name="cli-pegasus-aws-batch"></a><div class="titlepage"></div>
<div class="refnamediv">
<h2>Name</h2>
<p>pegasus-aws-batch — a client to run tasks on Amazon AWS Batch.</p>
</div>
<div class="refsynopsisdiv">
<a name="pegasus-aws-batch_synopsis"></a><h2>Synopsis</h2>
<div class="blockquote"><blockquote class="blockquote"><div class="literallayout"><p><span class="strong"><strong>pegasus-aws-batch</strong></span> [<span class="strong"><strong>-h</strong></span>]<br>
                    [<span class="strong"><strong>-C</strong></span> <span class="emphasis"><em>propsfile</em></span>]<br>
                    [<span class="strong"><strong>-L</strong></span>  <span class="emphasis"><em>&lt;error, warn, info, debug, trace&gt;</em></span>]<br>
                    [<span class="strong"><strong>-l</strong></span> <span class="emphasis"><em>logfile</em></span>]<br>
                    [<span class="strong"><strong>--merge-logs</strong></span> <span class="emphasis"><em>prefix</em></span>]<br>
                    [<span class="strong"><strong>-a</strong></span> <span class="emphasis"><em>AWS account id</em></span>]<br>
                    [<span class="strong"><strong>-r</strong></span> <span class="emphasis"><em>AWS region</em></span>]<br>
                    [<span class="strong"><strong>--create</strong></span>]<br>
                    [<span class="strong"><strong>--delete</strong></span>]<br>
                    [<span class="strong"><strong>-p</strong></span> <span class="emphasis"><em>prefix</em></span>]<br>
                    [<span class="strong"><strong>-j</strong></span> <span class="emphasis"><em>jsonfile or arn or job-definition name</em></span>]<br>
                    [<span class="strong"><strong>--ce</strong></span> <span class="emphasis"><em>jsonfile or arn or compute-environment name</em></span>]<br>
                    [<span class="strong"><strong>-q</strong></span> <span class="emphasis"><em>jsonfile or arn or queue name</em></span>]<br>
                    [<span class="strong"><strong>-s</strong></span>  <span class="emphasis"><em>s3 bucket URL</em></span>]<br>
                    [<span class="strong"><strong>-f</strong></span> <span class="emphasis"><em>file1</em></span>[,<span class="emphasis"><em>file2</em></span> …]]<br>
                    <span class="emphasis"><em>job submit file</em></span></p></div></blockquote></div>
</div>
<div class="refsect1">
<a name="pegasus-aws-batch_description"></a><h2>Description</h2>
<p><span class="strong"><strong>pegasus-aws-batch</strong></span> a client to run tasks on Amazon AWS Batch. Also
allows you to create and delete entities such as job definition,
compute environment and job queue required by AWS Batch Service. The
tool also allows you to upload files from your local machine to
the S3 bucket specified on the command line or the properties. This
allows you to ship data to S3 that your jobs running in AWS Batch
require. The tool will automatically fetch the stdout of your jobs
from the CloudWatch Logs and place it on the local filesystem.</p>
</div>
<div class="refsect1">
<a name="pegasus-aws-batch_options"></a><h2>Options</h2>
<div class="variablelist"><dl class="variablelist">
<dt>
<span class="term">
<span class="strong"><strong>-h</strong></span>
, </span><span class="term">
<span class="strong"><strong>--help</strong></span>
</span>
</dt>
<dd>
Show help message for subcommand and exit
</dd>
<dt>
<span class="term">
<span class="strong"><strong>-C</strong></span> <span class="emphasis"><em>propsfile</em></span>
, </span><span class="term">
<span class="strong"><strong>--conf</strong></span>=<span class="emphasis"><em>propsfile</em></span>
</span>
</dt>
<dd>
Path to the properties file containing the properties to configure the
too.
</dd>
<dt>
<span class="term">
<span class="strong"><strong>-L</strong></span>  <span class="emphasis"><em>&lt;error, warn, info, debug, trace&gt;</em></span>
, </span><span class="term">
<span class="strong"><strong>-log-level</strong></span>  <span class="emphasis"><em>&lt;error, warn, info, debug, trace&gt;</em></span>
</span>
</dt>
<dd>
Sets the log level for the tool.
</dd>
<dt>
<span class="term">
<span class="strong"><strong>-l</strong></span> <span class="emphasis"><em>logfile</em></span>
, </span><span class="term">
<span class="strong"><strong>--log-file</strong></span>=<span class="emphasis"><em>logfile</em></span>
</span>
</dt>
<dd>
Path to the file where you want the client to log to. By default,
client logs to it’s stdout and stderr.
</dd>
<dt>
<span class="term">
<span class="strong"><strong>-m</strong></span> <span class="emphasis"><em>prefix</em></span>
, </span><span class="term">
<span class="strong"><strong>--merge-logs</strong></span>=<span class="emphasis"><em>prefix</em></span>
</span>
</dt>
<dd>
By default, the tool pulls down the task stdout and stderr to separate
files with the name being determined by the job name specified in the
task submit file. The prefix is used for merging all the tasks stdout
to a single file starting with the name prefix and ending in
.out. Similar behavior is applied for the tasks stderr.
</dd>
<dt>
<span class="term">
<span class="strong"><strong>-a</strong></span> <span class="emphasis"><em>AWS account id</em></span>
, </span><span class="term">
<span class="strong"><strong>--account</strong></span>='AWS account id '
</span>
</dt>
<dd>
the AWS account to use for running jobs on AWS Batch. Can also be
specified in the properites using the property <span class="strong"><strong>pegasus.aws.account</strong></span>.
</dd>
<dt>
<span class="term">
<span class="strong"><strong>-a</strong></span> <span class="emphasis"><em>AWS region</em></span>
, </span><span class="term">
<span class="strong"><strong>--account</strong></span>=<span class="emphasis"><em>AWS region</em></span>
</span>
</dt>
<dd>
the AWS region in which the S3 bucket and other batch entitites
required by AWS batch exist. Can also be specified in the properites
using the property <span class="strong"><strong>pegasus.aws.region</strong></span>.
</dd>
<dt>
<span class="term">
<span class="strong"><strong>-c</strong></span>
, </span><span class="term">
<span class="strong"><strong>--create</strong></span>
</span>
</dt>
<dd>
<p class="simpara">
Only create the batch entities specified by  -j,--ce,-q,--s3 options
</p>
<div class="orderedlist"><ol class="orderedlist" type="1"><li class="listitem">
Don’t run any jobs.
</li></ol></div>
</dd>
<dt>
<span class="term">
<span class="strong"><strong>-d</strong></span>
, </span><span class="term">
<span class="strong"><strong>--delete</strong></span>
</span>
</dt>
<dd>
<p class="simpara">
Delete the batch entities specified by  -j,--ce,-q,--s3 options
</p>
<div class="orderedlist"><ol class="orderedlist" type="1"><li class="listitem">
Don’t run any jobs.
</li></ol></div>
</dd>
<dt>
<span class="term">
<span class="strong"><strong>-p</strong></span> <span class="emphasis"><em>prefix</em></span>
, </span><span class="term">
<span class="strong"><strong>--prefix</strong></span>=<span class="emphasis"><em>prefix</em></span>
</span>
</dt>
<dd>
The prefix to use for naming the batch entities created. Default
suffixes -job-definition, -compute-environment, -job-queue, -bucket
are added depending on the batch entity being created.
</dd>
<dt>
<span class="term">
<span class="strong"><strong>-j</strong></span> <span class="emphasis"><em>jsonfile or arn or job-definition name</em></span>
, </span><span class="term">
<span class="strong"><strong>--job-definition</strong></span> <span class="emphasis"><em>jsonfile or arn or job-definition name</em></span>
</span>
</dt>
<dd>
<p class="simpara">
 the json file containing job definition specification to register for
executing jobs or the ARN of existing job definition or basename of an
existing job definition. The JSON file format is same as the AWS Batch
format
<a class="ulink" href="https://docs.aws.amazon.com/batch/latest/userguide/job-definition-template.html" target="_top">https://docs.aws.amazon.com/batch/latest/userguide/job-definition-template.html</a>
A sample job definition file is listed in the configuration
section.
</p>
<p class="simpara">The value for this option can also be specified in the properites
using the property
<span class="strong"><strong>pegasus.aws.batch.job_definition</strong></span>.</p>
</dd>
<dt>
<span class="term">
<span class="strong"><strong>--ce</strong></span> <span class="emphasis"><em>jsonfile or arn or compute environment name</em></span>
, </span><span class="term">
<span class="strong"><strong>--compute-environment</strong></span> <span class="emphasis"><em>jsonfile or arn or compute environment name</em></span>
</span>
</dt>
<dd>
<p class="simpara">
the json file containing compute environment specification to create
in Amazon cloud for executing jobs or the ARN of existing compute
environment or basename of an existing compute environment. The JSON
file format is same as the AWS Batch format
<a class="ulink" href="https://docs.aws.amazon.com/batch/latest/userguide/compute-environment-template.html" target="_top">https://docs.aws.amazon.com/batch/latest/userguide/compute-environment-template.html</a>
A sample compute-environment file is listed in the configuration
section.
</p>
<p class="simpara">The value for this option can also be specified in the properites
using the property
<span class="strong"><strong>pegasus.aws.batch.compute_environment</strong></span>.</p>
</dd>
<dt>
<span class="term">
<span class="strong"><strong>-q</strong></span> <span class="emphasis"><em>jsonfile or arn or job queue name</em></span>
, </span><span class="term">
<span class="strong"><strong>--job-queue</strong></span> <span class="emphasis"><em>jsonfile or arn or job queue name</em></span>
</span>
</dt>
<dd>
<p class="simpara">
the json file containing job queue specification to create in Amazon
cloud for managing jobs. The queue is associated with the compute
environment on which the jobs are run, or basename of an existing job
queue. The JSON file format is same as the AWS Batch format
<a class="ulink" href="https://docs.aws.amazon.com/batch/latest/userguide/job-queue-template.html" target="_top">https://docs.aws.amazon.com/batch/latest/userguide/job-queue-template.html</a>
A sample job-queue file is listed in the configuration
section.
</p>
<p class="simpara">The value for this option can also be specified in the properites
using the property
<span class="strong"><strong>pegasus.aws.batch.job_queue</strong></span>.</p>
</dd>
<dt>
<span class="term">
<span class="strong"><strong>-s</strong></span> <span class="emphasis"><em>s3 URL</em></span>
, </span><span class="term">
<span class="strong"><strong>--s3</strong></span> <span class="emphasis"><em>s3 URL</em></span>
</span>
</dt>
<dd>
<p class="simpara">
The S3 bucket to use for lifecycle of the client. If not specifed then
a bucket is created based on the prefix passed.
</p>
<p class="simpara">The value for this option can also be specified in the properites
using the property
<span class="strong"><strong>pegasus.aws.batch.s3_bucket</strong></span>.</p>
</dd>
<dt>
<span class="term">
<span class="strong"><strong>-f</strong></span> <span class="emphasis"><em>file</em></span>[,<span class="emphasis"><em>file</em></span>,…]
, </span><span class="term">
<span class="strong"><strong>--files</strong></span> <span class="emphasis"><em>file</em></span>[,<span class="emphasis"><em>file</em></span>,…]
</span>
</dt>
<dd>
A comma separated list of files that need to be copied to the
associated  s3 bucket before any task starts.
</dd>
</dl></div>
<p><span class="emphasis"><em>job submit file</em></span>
A JSON formatted file that contains the job description of the jobs
that need to be executed. A sample job description file is listed in
the configuration section.</p>
</div>
<div class="refsect1">
<a name="AWS_CONFIGURATION"></a><h2>Configuration</h2>
<p>Each user should specify a configuration file that <span class="strong"><strong>pegasus-aws-batch</strong></span>
will use to authentication tokens. It is the same as standard Amazon
EC2 credentials file and default Amazon search path semantics apply.</p>
<div class="refsect2">
<a name="pegasus-aws-batch_sample_file"></a><h3>Sample File</h3>
<p>$ cat ~/.aws/credentials</p>
<p>aws_access_key_id = XXXXXXXXXXXX
aws_secret_access_key = XXXXXXXXXXX</p>
</div>
<div class="refsect2">
<a name="pegasus-aws-batch_configuration_properties"></a><h3>Configuration Properties</h3>
<div class="variablelist"><dl class="variablelist">
<dt><span class="term">
<span class="strong"><strong>endpoint</strong></span> (site)
</span></dt>
<dd>
The URL of the web service endpoint. If the URL begins with <span class="emphasis"><em>https</em></span>, then SSL will be used.
</dd>
</dl></div>
<p><span class="strong"><strong>pegasus.aws.account</strong></span> (aws account)
The AWS region to use. Can alse be specified by -a option.</p>
<p><span class="strong"><strong>pegasus.aws.region</strong></span> (region)
The AWS region to use. Can alse be specified by -r option.</p>
<p><span class="strong"><strong>pegasus.aws.batch.job_definition</strong></span> (the json file or existing ARN or basename)
Can alse be specified by -j option.</p>
<p><span class="strong"><strong>pegasus.aws.batch.compute_environment</strong></span> (the json file or existing ARN or basename)
Can alse be specified by --ce option.</p>
<p><span class="strong"><strong>pegasus.aws.batch.job_queue</strong></span> (the json file or existing ARN or basename)
Can alse be specified by -q option.</p>
<p><span class="strong"><strong>pegasus.aws.batch.s3_bucket</strong></span> (the S3 URL)
Can alse be specified by --s3 option.</p>
</div>
<div class="refsect2">
<a name="pegasus-aws-batch_example_json_files"></a><h3>Example JSON Files</h3>
<p>Example JSON files are listed below</p>
</div>
</div>
<div class="refsect1">
<a name="pegasus-aws-batch_job_definition_file"></a><h2>Job Definition File</h2>
<p>A sample job definition file. Update to reflect your settings.</p>
<pre class="screen">$ cat  sample-job-definition.json

{
  "containerProperties": {
    "mountPoints": [],
    "image": "XXXXXXXXXXX.dkr.ecr.us-west-2.amazonaws.com/awsbatch/fetch_and_run",
    "jobRoleArn": "batchJobRole"  ,
    "environment": [ {
            "name": "PEGASUS_EXAMPLE",
            "value": "batch-black"
         }],
    "vcpus": 1,
    "command": [
      "/bin/bash",
      "-c",
      "exit $AWS_BATCH_JOB_ATTEMPT"
    ],
    "volumes": [],
    "memory": 500,
    "ulimits": []
  },
  "retryStrategy": {
    "attempts": 1
  },
  "parameters": {},
  "type": "container"
}</pre>
</div>
<div class="refsect1">
<a name="pegasus-aws-batch_compute_environment_file"></a><h2>Compute Environment File</h2>
<p>A sample job definition file. Update to reflect your settings.</p>
<pre class="screen">$ cat conf/sample-compute-env.json
{

  "state": "ENABLED",
  "type": "MANAGED",
  "computeResources": {
    "subnets": [
      "subnet-a9bb63cc"
    ],
    "type": "EC2",
    "tags": {
      "Name": "Batch Instance - optimal"
    },
    "desiredvCpus": 0,
    "minvCpus": 0,
    "instanceTypes": [
      "optimal"
    ],
    "securityGroupIds": [
      "sg-91d645f4"
    ],
    "instanceRole": "ecsInstanceRole" ,
    "maxvCpus": 2,
    "bidPercentage": 20
  },
  "serviceRole": "AWSBatchServiceRole"
}</pre>
</div>
<div class="refsect1">
<a name="pegasus-aws-batch_job_queue_file"></a><h2>Job Queue File</h2>
<p>A sample job definition file. Update to reflect your settings.</p>
<pre class="screen">$  cat conf/sample-job-queue.json
{
  "priority": 10,
  "state": "ENABLED",
  "computeEnvironmentOrder": [
    {
      "order": 1
    }
  ]
}</pre>
</div>
<div class="refsect1">
<a name="pegasus-aws-batch_job_submit_file"></a><h2>Job Submit File</h2>
<p>A sample job submit file that lists the bag of jobs that need to be
executed on AWS Batch</p>
<pre class="screen">$ cat merge_diamond-findrange-4_0_PID2_ID1.in
{
  "SubmitJob" : [ {
    "jobName" : "findrange_ID0000002",
    "executable" : "pegasus-aws-batch-launch.sh",
    "arguments" : "findrange_ID0000002.sh",
    "environment" : [ {
      "name" : "S3CFG_aws_batch",
      "value" : "s3://pegasus-batch-bamboo/mybatch-bucket/run0001/.s3cfg"
    }, {
      "name" : "TRANSFER_INPUT_FILES",
      "value" : "/scitech/input/pegasus-worker-4.9.0dev-x86_64_rhel_7.tar.gz,/scitech/input/00/00/findrange_ID0000002.sh"
    }, {
      "name" : "BATCH_FILE_TYPE",
      "value" : "script"
    }, {
      "name" : "BATCH_FILE_S3_URL",
      "value" : "s3://pegasus-batch-bamboo/mybatch-bucket/run0001/pegasus-aws-batch-launch.sh"
    } ]
  }, {
    "jobName" : "findrange_ID0000003",
    "executable" : "pegasus-aws-batch-launch.sh",
    "arguments" : "findrange_ID0000003.sh",
    "environment" : [ {
      "name" : "S3CFG_aws_batch",
      "value" : "s3://pegasus-batch-bamboo/mybatch-bucket/run0001/.s3cfg"
    }, {
      "name" : "TRANSFER_INPUT_FILES",
      "value" : "/scitech/input/pegasus-worker-4.9.0dev-x86_64_rhel_7.tar.gz,/scitech/input/00/00/findrange_ID0000003.sh"
    }, {
      "name" : "BATCH_FILE_TYPE",
      "value" : "script"
    }, {
      "name" : "BATCH_FILE_S3_URL",
      "value" : "s3://pegasus-batch-bamboo/mybatch-bucket/run0001/pegasus-aws-batch-launch.sh"
    } ]
  } ]
}</pre>
</div>
<div class="refsect1">
<a name="pegasus-aws-batch_file_transfers"></a><h2>File Transfers</h2>
<p>The tool allows you to upload files to the associated S3 bucket from
the local filesystem in two ways.
a. Common Files Required For All Jobs</p>
<p>+
You can the command line option <span class="strong"><strong>--files</strong></span> to give a comma separated
list of files to transfer.</p>
<p>+
b. TRANSFER_INPUT_FILES Environment Variable</p>
<p>+
You can also associate in the job submit a file, an enviornment
variable named <span class="strong"><strong>TRANSFER_INPUT_FILES</strong></span> for each job that the tool will
transfer at the time of job submission. The value for the environment
variable is a comma separated list of files.</p>
</div>
<div class="refsect1">
<a name="pegasus-aws-batch_return_value"></a><h2>Return Value</h2>
<p><span class="strong"><strong>pegasus-aws-batch</strong></span> returns a zero exist status if the operation is
successful. A non-zero exit status is returned in case of failure. If
you run any jobs using the tool, then tool will return with a non
zero exitcode in case one or more of your tasks fail.</p>
</div>
<div class="refsect1">
<a name="pegasus-aws-batch_author"></a><h2>Author</h2>
<p>Karan Vahi <code class="literal">&lt;vahi@isi.edu&gt;</code></p>
<p>Pegasus Team <a class="ulink" href="http://pegasus.isi.edu" target="_top">http://pegasus.isi.edu</a></p>
</div>
</div><div class="navfooter">
<hr>
<table width="100%" summary="Navigation footer">
<tr>
<td width="40%" align="left">
<a accesskey="p" href="cli-pegasus-analyzer.php">Prev</a> </td>
<td width="20%" align="center"><a accesskey="u" href="cli.php">Up</a></td>
<td width="40%" align="right"> <a accesskey="n" href="cli-pegasus-cluster.php">Next</a>
</td>
</tr>
<tr>
<td width="40%" align="left" valign="top">pegasus-analyzer </td>
<td width="20%" align="center"><a accesskey="h" href="index.php">Table of Contents</a></td>
<td width="40%" align="right" valign="top"> pegasus-cluster</td>
</tr>
</table>
</div><?php  
            pegasus_footer();
        ?>
