<?php  
            require('/srv2/pegasus.isi.edu/includes/common.php'); 
            pegasus_header("pegasus-transfer");
        ?><div class="breadcrumbs">
<span class="breadcrumb-link"><a href="index.php">Pegasus 4.9.3 User Guide</a></span> &gt; <span class="breadcrumb-link"><a href="cli.php">Command Line Tools</a></span> &gt; <span class="breadcrumb-node">pegasus-transfer</span>
</div><hr><div lang="en" class="refentry">
<a name="cli-pegasus-transfer"></a><div class="titlepage"></div>
<div class="refnamediv">
<h2>Name</h2>
<p>pegasus-transfer — Handles data transfers for Pegasus workflows.</p>
</div>
<div class="refsynopsisdiv">
<a name="pegasus-transfer_synopsis"></a><h2>Synopsis</h2>
<div class="blockquote"><blockquote class="blockquote"><div class="literallayout"><p><span class="strong"><strong>pegasus-transfer</strong></span> [<span class="strong"><strong>-h</strong></span>]<br>
                   [<span class="strong"><strong>--file</strong></span> <span class="emphasis"><em>inputfile</em></span>]<br>
                   [<span class="strong"><strong>--threads</strong></span> <span class="emphasis"><em>number_threads</em></span>]<br>
                   [<span class="strong"><strong>--max-attempts</strong></span> <span class="emphasis"><em>attempts</em></span>]<br>
                   [<span class="strong"><strong>--threads</strong></span> <span class="emphasis"><em>threads</em></span>]<br>
                   [<span class="strong"><strong>--symlink</strong></span>]<br>
                   [<span class="strong"><strong>--debug</strong></span>]</p></div></blockquote></div>
</div>
<div class="refsect1">
<a name="pegasus-transfer_description"></a><h2>Description</h2>
<p><span class="strong"><strong>pegasus-transfer</strong></span> takes a JSON defined list of urls, either through  stdin
or with an input file, determines the correct tool to use for the transfer
and  executes the transfer. Some of the protocols pegasus-transfer can
handle are GridFTP, SCP, SRM, Amazon S3, Google Storage, XRootD, HTTP,
Docker, Singularity, and local cp/symlinking. Failed transfers are retried.</p>
<p>Note that pegasus-transfer is a tool mostly used internally in Pegasus
workflows, but the tool can be used stand alone as well.</p>
</div>
<div class="refsect1">
<a name="pegasus-transfer_options"></a><h2>Options</h2>
<div class="variablelist"><dl class="variablelist">
<dt>
<span class="term">
<span class="strong"><strong>-h</strong></span>
, </span><span class="term">
<span class="strong"><strong>--help</strong></span>
</span>
</dt>
<dd>
Prints a usage summary with all the available command-line options.
</dd>
<dt>
<span class="term">
<span class="strong"><strong>-f</strong></span> <span class="emphasis"><em>FILE</em></span>
, </span><span class="term">
<span class="strong"><strong>--file=FILE</strong></span>
</span>
</dt>
<dd>
File containing URL pairs to be transferred. If not given, list is read
from stdin.
</dd>
<dt>
<span class="term">
<span class="strong"><strong>-m</strong></span> <span class="emphasis"><em>MAX_ATTEMPTS</em></span>
, </span><span class="term">
<span class="strong"><strong>--max-attempts=MAX_ATTEMPTS</strong></span>
</span>
</dt>
<dd>
Number of attempts allowed for each transfer. Default is 3.
</dd>
<dt>
<span class="term">
<span class="strong"><strong>-n</strong></span> <span class="emphasis"><em>THREADS</em></span>
, </span><span class="term">
<span class="strong"><strong>--threads=THREADS</strong></span>
</span>
</dt>
<dd>
Number of threads to process transfers. Default is 8. This option can also
be set via the PEGASUS_TRANSFER_THREADS environment variable. The command line
option takes precedence over the environment variable.
</dd>
<dt>
<span class="term">
<span class="strong"><strong>-s</strong></span>
, </span><span class="term">
<span class="strong"><strong>--symlink</strong></span>
</span>
</dt>
<dd>
Allow symlinking of file URLs. If the source and destination URLs chosen
are both file URLs with the same site_label then the source file will be
symlinked to the destination rather than being copied.
</dd>
<dt>
<span class="term">
<span class="strong"><strong>-d</strong></span>
, </span><span class="term">
<span class="strong"><strong>--debug</strong></span>
</span>
</dt>
<dd>
Enables debugging ouput.
</dd>
</dl></div>
</div>
<div class="refsect1">
<a name="pegasus-transfer_example"></a><h2>Example</h2>
<pre class="screen">$ pegasus-transfer
[
 { "type": "transfer",
   "id": 1,
   "src_urls": [ { "site_label": "web", "url": "http://pegasus.isi.edu" } ],
   "dest_urls": [ { "site_label": "local", "url": "file:///tmp/index.html" } ]
 }
]
CTRL+D</pre>
</div>
<div class="refsect1">
<a name="pegasus-transfer_credential_handling"></a><h2>Credential Handling</h2>
<p>Credentials used for transfers can be specified with a combination of
site labels in the input JSON format and environment variables. For example,
give the following input file:</p>
<pre class="screen">[
 { "type": "transfer",
   "id": 1,
   "src_urls": [ { "site_label": "isi", "url": "gsiftp://workflow.isi.edu/data/file.dat" } ],
   "dest_urls": [ { "site_label": "tacc_stampede", "url": "gsiftp://gridftp.stampede.tacc.utexas.edu/scratch/file.dat" } ]
 }
]</pre>
<p>pegasus-transfer will expect either one environment variable specifying
one credential to be used on both end of the connection (X509_USER_PROXY),
or two separate environment variables specifying two different credentials
to be used on the two ends of the connection. In the latter case, the
environment variables are derived from the site labels. In the example
above, the environment variables would be named X509_USER_PROXY_isi
and X509_USER_PROXY_tacc_stampede</p>
</div>
<div class="refsect1">
<a name="pegasus-transfer_threading"></a><h2>Threading</h2>
<p>In order to speed up data transfers, pegasus-transfer will start a set
of transfers in parallel using threads.</p>
</div>
<div class="refsect1">
<a name="pegasus-transfer_preference_of_gfal_over_guc"></a><h2>Preference of GFAL over GUC</h2>
<p>JGlobus is no longer actively supported and is not in compliance RFC 2818.
As a result cleanup jobs using pegasus-gridftp client would fail
against the servers supporting the strict mode. We have removed the
pegasus-gridftp client and now use gfal clients as globus-url-copy
does not support removes. If gfal is not available, globus-url-copy is
used for cleanup by writing out zero bytes files instead of removing
them.</p>
<p>If you want to force globus-url-copy to be preferred over GFAL, set the
PEGASUS_FORCE_GUC=1 environment variable in the site catalog for the
sites you want the preference to be enforced. Please note that we expect
globus-url-copy support to be completely removed in future releases of
Pegasus due to the end of life of Globus Toolkit in 2018.</p>
</div>
<div class="refsect1">
<a name="pegasus-transfer_author"></a><h2>Author</h2>
<p>Pegasus Team <a class="ulink" href="http://pegasus.isi.edu" target="_top">http://pegasus.isi.edu</a></p>
</div>
</div><div class="navfooter">
<hr>
<table width="100%" summary="Navigation footer">
<tr>
<td width="40%" align="left">
<a accesskey="p" href="cli-pegasus-tc-converter.php">Prev</a> </td>
<td width="20%" align="center"><a accesskey="u" href="cli.php">Up</a></td>
<td width="40%" align="right"> <a accesskey="n" href="cli-pegasus-version.php">Next</a>
</td>
</tr>
<tr>
<td width="40%" align="left" valign="top">pegasus-tc-converter </td>
<td width="20%" align="center"><a accesskey="h" href="index.php">Table of Contents</a></td>
<td width="40%" align="right" valign="top"> pegasus-version</td>
</tr>
</table>
</div><?php  
            pegasus_footer();
        ?>
