<?php  
            require('/srv2/pegasus.isi.edu/includes/common.php'); 
            pegasus_header("Chapter 13. Configuration");
        ?><div class="breadcrumbs">
<span class="breadcrumb-link"><a href="index.php">Pegasus 4.9.3 User Guide</a></span> &gt; <span class="breadcrumb-node">Configuration</span>
</div><hr><div class="chapter">
<div class="titlepage"><div><div><h1 class="title">
<a name="configuration"></a>Chapter 13. Configuration</h1></div></div></div>
<div class="toc"><dl class="toc">
<dt><span class="section"><a href="configuration.php#idm6304">13.1. Differences between Profiles and Properties</a></span></dt>
<dt><span class="section"><a href="profiles.php">13.2. Profiles</a></span></dt>
<dt><span class="section"><a href="properties.php">13.3. Properties</a></span></dt>
</dl></div>
<p>Pegasus has configuration options to configure</p>
<div class="orderedlist"><ol class="orderedlist" type="1">
<li class="listitem"><p>the behavior of an individual job via <span class="bold"><strong>profiles</strong></span></p></li>
<li class="listitem"><p>the behavior of the whole system via <span class="bold"><strong>properties</strong></span></p></li>
</ol></div>
<p>For job level configuration ( such as what environment a job is set
  with ), the Pegasus Workflow Mapper uses the concept of profiles. Profiles
  encapsulate configurations for various aspects of dealing with the Grid
  infrastructure. They provide an abstract yet uniform interface to specify
  configuration options for various layers from planner/mapper behavior to
  remote environment settings. At various stages during the mapping process,
  profiles may be added associated with the job. The system supports five
  diffferent namespaces, with each namespace refers to a different aspect of a
  job's runtime settings. A profile's representation in the executable
  workflow (e.g. the Condor submit files) depends on its namespace. Pegasus
  supports the following Namespaces for profiles:</p>
<div class="itemizedlist"><ul class="itemizedlist" style="list-style-type: disc; ">
<li class="listitem"><p><span class="bold"><strong>env</strong></span> permits remote environment
      variables to be set.</p></li>
<li class="listitem"><p><span class="bold"><strong>globus</strong></span> sets Globus RSL
      parameters.</p></li>
<li class="listitem"><p><span class="bold"><strong>condor</strong></span> sets Condor configuration
      parameters for the submit file.</p></li>
<li class="listitem"><p><span class="bold"><strong>dagman</strong></span> introduces Condor DAGMan
      configuration parameters.</p></li>
<li class="listitem"><p><span class="bold"><strong>pegasus</strong></span> configures the behaviour
      of various planner/mapper components.</p></li>
<li class="listitem"><p><span class="bold"><strong>hints</strong></span> allows to override site
      selection behavior of the planner. Can be specified only in the
      DAX.</p></li>
</ul></div>
<p>Properties are primarily used to configure the behavior of the Pegasus
  WMS system at a global level. The properties file is actually a java
  properties file and follows the same conventions as that to specify the
  properties.</p>
<p>This chapter describes various types of profiles and properties,
  levels of priorities for intersecting profiles, and how to specify profiles
  in different contexts.</p>
<div class="section">
<div class="titlepage"><div><div><h2 class="title" style="clear: both">
<a name="idm6304"></a>13.1. Differences between Profiles and Properties</h2></div></div></div>
<p>The main difference between properties and profiles is that profiles
    eventually get associated at a per job level in the workflow. On the other
    hand, properties are a way of configuring and controlling the behavior of
    the whole system. While all profiles can be specified in the properties
    file, not all properties can be used as profiles. This section lists out
    the properties supported by Pegasus and if any can be used as a profile,
    it is clearly indicated.</p>
</div>
</div><div class="navfooter">
<hr>
<table width="100%" summary="Navigation footer">
<tr>
<td width="40%" align="left">
<a accesskey="p" href="service_ensemble.php">Prev</a> </td>
<td width="20%" align="center"> </td>
<td width="40%" align="right"> <a accesskey="n" href="profiles.php">Next</a>
</td>
</tr>
<tr>
<td width="40%" align="left" valign="top">12.4. Ensemble Manager </td>
<td width="20%" align="center"><a accesskey="h" href="index.php">Table of Contents</a></td>
<td width="40%" align="right" valign="top"> 13.2. Profiles</td>
</tr>
</table>
</div><?php  
            pegasus_footer();
        ?>
