<?php  
            require('/srv2/pegasus.isi.edu/includes/common.php'); 
            pegasus_header("8.4. Container Execution Model");
        ?><div class="breadcrumbs">
<span class="breadcrumb-link"><a href="index.php">Pegasus 4.9.3 User Guide</a></span> &gt; <span class="breadcrumb-link"><a href="containers.php">Containers</a></span> &gt; <span class="breadcrumb-node">Container Execution Model</span>
</div><hr><div class="section">
<div class="titlepage"><div><div><h2 class="title" style="clear: both">
<a name="container-exec-model"></a>8.4. Container Execution Model</h2></div></div></div>
<p>User's containerized applications are launched as part of
    PegasusLite jobs. PegasusLite job when starting on a remote worker
    node.</p>
<div class="orderedlist"><ol class="orderedlist" type="1">
<li class="listitem"><p>Sets up a directory to run a user job in.</p></li>
<li class="listitem"><p>Pulls the container image to that directory</p></li>
<li class="listitem"><p>Optionally, loads the container from the container image file
        and sets up the user to run as in the container (only applicable for
        Docker containers)</p></li>
<li class="listitem"><p>Mounts the job directory into the container as /scratch for
        Docker containers, while as /srv for Singularity containers.</p></li>
<li class="listitem">
<p>Container will run a job specific script that figures created by
        PegasusLite that does the following:</p>
<div class="orderedlist"><ol class="orderedlist" type="a">
<li class="listitem"><p>Figures the appropriate Pegasus worker to use in the
            container if not already installed</p></li>
<li class="listitem"><p>Sets up the job environment to use including transfer and
            setup of any credentials transferred as part of PegasusLite</p></li>
<li class="listitem"><p>Pulls in all the relevant input data, executables required
            by the job</p></li>
<li class="listitem"><p>Launches the user application using
            <span class="emphasis"><em>pegasus-kickstart.</em></span></p></li>
</ol></div>
</li>
<li class="listitem"><p>Optionally, shuts down the container (only applicable for Docker
        containers)</p></li>
<li class="listitem"><p>Ships out the output data to the staging site</p></li>
<li class="listitem"><p>Cleans up the directory on the worker node.</p></li>
</ol></div>
<div class="note" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Note</h3>
<p>Starting Pegasus 4.9.1 the container data transfer model has been
      changed. Instead of data transfers for the job occurring outside the
      container in the PegasusLite wrapper, they now happen when the user job
      starts in the container.</p>
</div>
<p>In versions of Pegasus &gt;= 4.9.1 the transfers are handled from
    within the container, and thus container recipes require some extra
    attention. A Dockerfile example that prepares a container for GridFTP
    transfers is provided below.</p>
<p>In this example there are three sections. </p>
<div class="itemizedlist"><ul class="itemizedlist" style="list-style-type: disc; ">
<li class="listitem"><p>Essential Packages</p></li>
<li class="listitem"><p>Install Globus Toolkit</p></li>
<li class="listitem"><p>Install CA Certs</p></li>
</ul></div>
<p> From the "Essential Packages", <span class="bold"><strong>python</strong></span> and either <span class="bold"><strong>curl</strong></span> or <span class="bold"><strong>wget</strong></span> have
    to be present. "Install Globus Toolkit", sets up the enviroment for
    GridFTP transfers. And "Install CA Certs" copies the grid certificates in
    the container.</p>
<div class="note" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Note</h3>
<p>Globus Toolkit introduced some breaking changes in August 2018 to
      its authentication module, and some sites haven't upgraded their
      installations (eg. NERSC). GridFTP in order to authenticate
      successfully, requires the libglobus-gssapi-gsi4 package to be pinned to
      the version 13.8-1. The code snipet below contains installation
      directives to handle this but they are commented out.</p>
</div>
<pre class="programlisting">
##########################################
#### This Container Supports GridFTP  ####
##########################################

FROM ubuntu:18.04

#### Essential Packages ####
RUN apt-get update &amp;&amp;\
apt-get install -y software-properties-common curl wget python unzip &amp;&amp;\
rm -rf /var/lib/apt/lists/*

#### Install Globus Toolkit ####
RUN wget -nv http://www.globus.org/ftppub/gt6/installers/repo/globus-toolkit-repo_latest_all.deb &amp;&amp;\
dpkg -i globus-toolkit-repo_latest_all.deb &amp;&amp;\
apt-get update &amp;&amp;\
# apt-get install -y libglobus-gssapi-gsi4=13.8-1+gt6.bionic &amp;&amp;\
# apt-mark hold libglobus-gssapi-gsi4 &amp;&amp;\
apt-get install -y globus-data-management-client &amp;&amp;\
rm -f globus-toolkit-repo_latest_all.deb &amp;&amp;\
rm -rf /var/lib/apt/lists/*

#### Install CA Certs ####
RUN mkdir -p /etc/grid-security &amp;&amp;\
cd /etc/grid-security &amp;&amp;\
wget -nv https://download.pegasus.isi.edu/containers/certificates.tar.gz &amp;&amp;\
tar xzf certificates.tar.gz &amp;&amp;\
rm -f certificates.tar.gz

##########################################
#### Your Container Specific Commands ####
##########################################
   </pre>
</div><div class="navfooter">
<hr>
<table width="100%" summary="Navigation footer">
<tr>
<td width="40%" align="left">
<a accesskey="p" href="containers_osg.php">Prev</a> </td>
<td width="20%" align="center"><a accesskey="u" href="containers.php">Up</a></td>
<td width="40%" align="right"> <a accesskey="n" href="container-transfers.php">Next</a>
</td>
</tr>
<tr>
<td width="40%" align="left" valign="top">8.3. Containers on OSG </td>
<td width="20%" align="center"><a accesskey="h" href="index.php">Table of Contents</a></td>
<td width="40%" align="right" valign="top"> 8.5. Staging of Application Containers</td>
</tr>
</table>
</div><?php  
            pegasus_footer();
        ?>
