<?php  
            require('/srv2/pegasus.isi.edu/includes/common.php'); 
            pegasus_header("8.3. Containers on OSG");
        ?><div class="breadcrumbs">
<span class="breadcrumb-link"><a href="index.php">Pegasus 4.9.3 User Guide</a></span> &gt; <span class="breadcrumb-link"><a href="containers.php">Containers</a></span> &gt; <span class="breadcrumb-node">Containers on OSG</span>
</div><hr><div class="section">
<div class="titlepage"><div><div><h2 class="title" style="clear: both">
<a name="containers_osg"></a>8.3. Containers on OSG</h2></div></div></div>
<p>OSG has it's own way of handling container deployments for jobs that
    is hidden from the user and hence Pegasus. They don't allow a user to run
    an image directly by invoking docker run or singluarity exec. Instead the
    condor job wrappers deployed on OSG do it for you based on the classads
    associated with the job. As a result, for a workflow to run on OSG, one
    cannot specify or describe the container in the transformation catalog.
    Instead you catalog the executables without a container reference, and the
    path to the executable is the path in the container you want to use. To
    specify the container, that needs to be setup you instead specify the
    following Condor profiles</p>
<div class="table">
<a name="osg_singluarity_condor_profiles"></a><p class="title"><b>Table 8.1. Condor Profiles For Specifying Singularity Container for
      Jobs</b></p>
<div class="table-contents"><table class="table" summary="Condor Profiles For Specifying Singularity Container for
      Jobs" border="1">
<colgroup>
<col align="center">
<col>
</colgroup>
<thead><tr>
<th align="center">Key</th>
<th align="center">Value</th>
</tr></thead>
<tbody>
<tr>
<td align="center">requirements</td>
<td>HAS_SINGULARITY == True</td>
</tr>
<tr>
<td align="center">+SingularityImage</td>
<td>path to singluarity image on CVMFS</td>
</tr>
</tbody>
</table></div>
</div>
<br class="table-break"><p>For example you can specify the following in the site catalog for
    OSG site</p>
<pre class="programlisting">&lt;!-- this is our execution site --&gt;
    &lt;site  handle="OSG" arch="x86_64" os="LINUX"&gt;
        &lt;profile namespace="pegasus" key="style" &gt;condor&lt;/profile&gt;
        &lt;profile namespace="condor" key="universe" &gt;vanilla&lt;/profile&gt;<span class="bold"><strong>
        &lt;profile namespace="condor" key="requirements" &gt;HAS_SINGULARITY == True&lt;/profile&gt;</strong></span>
        <span class="bold"><strong>&lt;profile namespace="condor" key="+SingularityImage" &gt;"/cvmfs/singularity.opensciencegrid.org/pegasus/osg-el7:latest"&lt;/profile&gt;</strong></span>
        &lt;profile namespace="condor" key="request_cpus" &gt;1&lt;/profile&gt;
        &lt;profile namespace="condor" key="request_memory" &gt;1 GB&lt;/profile&gt;
        &lt;profile namespace="condor" key="request_disk" &gt;1 GB&lt;/profile&gt;
    &lt;/site&gt;</pre>
</div><div class="navfooter">
<hr>
<table width="100%" summary="Navigation footer">
<tr>
<td width="40%" align="left">
<a accesskey="p" href="container-configuration.php">Prev</a> </td>
<td width="20%" align="center"><a accesskey="u" href="containers.php">Up</a></td>
<td width="40%" align="right"> <a accesskey="n" href="container-exec-model.php">Next</a>
</td>
</tr>
<tr>
<td width="40%" align="left" valign="top">8.2. Configuring Workflows To Use Containers </td>
<td width="20%" align="center"><a accesskey="h" href="index.php">Table of Contents</a></td>
<td width="40%" align="right" valign="top"> 8.4. Container Execution Model</td>
</tr>
</table>
</div><?php  
            pegasus_footer();
        ?>
