<?php  
            require('/srv2/pegasus.isi.edu/includes/common.php'); 
            pegasus_header("6.7. Publishing to AMQP Message Servers");
        ?><div class="breadcrumbs">
<span class="breadcrumb-link"><a href="index.php">Pegasus 4.9.3 User Guide</a></span> &gt; <span class="breadcrumb-link"><a href="monitoring_debugging_stats.php">Monitoring, Debugging and Statistics</a></span> &gt; <span class="breadcrumb-node">Publishing to AMQP Message Servers</span>
</div><hr><div class="section">
<div class="titlepage"><div><div><h2 class="title" style="clear: both">
<a name="monitoring_amqp"></a>6.7. Publishing to AMQP Message Servers</h2></div></div></div>
<div class="toc"><dl class="toc">
<dt><span class="section"><a href="monitoring_amqp.php#idm3470">6.7.1. Configuration</a></span></dt>
<dt><span class="section"><a href="monitoring_amqp.php#amqp_rabbitmq_es">6.7.2. Monitord, RabbitMQ, ElasticSearch Example</a></span></dt>
<dt><span class="section"><a href="monitoring_amqp.php#elk_stack_infrastructure">6.7.3. A Pre-Configured Data Collection Pipeline</a></span></dt>
</dl></div>
<p>The<a class="link" href="stampede_wf_events.php" title="6.6. Stampede Workflow Events"> workflow events</a>
    generated by <span class="emphasis"><em>pegasus-monitord </em></span>can also be used to
    publish to an AMQP message server such as RabbitMQ in addition to the
    stampede workflow database.</p>
<div class="note" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Note</h3>
<p>A thing to keep in mind. The workflow events are documented as
      conforming to the netlogger requirements. When events are pushed to an
      AMQP endpoint, the . in the keys are replaced by _ .</p>
</div>
<div class="section">
<div class="titlepage"><div><div><h3 class="title">
<a name="idm3470"></a>6.7.1. Configuration</h3></div></div></div>
<p>In order to get <span class="emphasis"><em>pegasus-monitord</em></span> to populate
      to a message queue, you can set the following property</p>
<pre class="programlisting">pegasus.catalog.workflow.amqp.url amqp://[USERNAME:PASSWORD@]amqp.isi.edu[:port]/&lt;exchange_name&gt; </pre>
<p>The routing key set for the messages matches the name of the
      stampede workflow event being sent. By default, if you enable AMQP
      population only the following events are sent to the server</p>
<div class="itemizedlist"><ul class="itemizedlist" style="list-style-type: disc; ">
<li class="listitem"><p>stampede.job_inst.tag</p></li>
<li class="listitem"><p>stampede.inv.end</p></li>
<li class="listitem"><p>stampede.wf.plan</p></li>
</ul></div>
<p>To configure additional events, you can specify a comma separated
      list of events that need to be sent using the property <span class="bold"><strong>pegasus.catalog.workflow.amqp.events </strong></span>. For
      example</p>
<pre class="programlisting">pegasus.catalog.workflow.amqp.events = stampede.xwf.*,stampede.static.*</pre>
<div class="note" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Note</h3>
<p>To get all events you can just specify * as the value to the
        property.</p>
</div>
</div>
<div class="section">
<div class="titlepage"><div><div><h3 class="title">
<a name="amqp_rabbitmq_es"></a>6.7.2. Monitord, RabbitMQ, ElasticSearch Example</h3></div></div></div>
<p>The AMQP support in Monitord is still a work in progress, but even
      the current functionality provides basic support for getting the
      monitoring data into ElasticSearch. In our development environment, we
      use a RabbitMQ instance with a simple exhange/queue. The configuration
      required for Pegasus is:</p>
<pre class="programlisting"># help Pegasus developers collect data on integrity failures                                        
pegasus.monitord.encoding = json                                                                    
pegasus.catalog.workflow.amqp.url = amqp://friend:donatedata@msgs.pegasus.isi.edu:5672/prod/workflows
          </pre>
<p>On the other side of the queue, Logstash is configured to receive
      the messages and forward them to ElasticSearch. The Logstash pipeline
      looks something like:</p>
<pre class="programlisting">
input {
  rabbitmq {
    type =&gt; "workflow-events"
    host =&gt; "msg.pegasus.isi.edu"
    vhost =&gt; "prod"
    queue =&gt; "workflows-es"
    heartbeat =&gt; 30
    durable =&gt; true
    password =&gt; "XXXXXX"
    user =&gt; "prod-logstash"
  }
}

filter {
  if [type] == "workflow-events" {
    mutate {
      convert =&gt; {
        "dur" =&gt; "float"
        "remote_cpu_time" =&gt; "float"
      }
    }
    date {
      # set @timestamp from the ts of the actual event
      match =&gt; [ "ts", "UNIX" ]
    }
    date {
      match =&gt; [ "start_time", "UNIX" ]
      target =&gt; "start_time_human"
    }
    fingerprint {
      # create unique document ids
      source =&gt; "ts"
      concatenate_sources =&gt; true
      method =&gt; "SHA1"
      key =&gt; "Pegasus Event"
      target =&gt; "[@metadata][fingerprint]"
    }
  }
}
  
output {
  if [type] == "workflow-events" {
    elasticsearch {
      "hosts" =&gt; ["es1.isi.edu:9200", "es2.isi.edu:9200"]
      "sniffing" =&gt; false
      "document_type" =&gt; "workflow-events"
      "document_id" =&gt; "%{[@metadata][fingerprint]}"
      "index" =&gt; "workflow-events-%{+YYYY.MM.dd}"
      "template" =&gt; "/usr/share/logstash/templates/workflow-events.json"
      "template_name" =&gt; "workflow-events-*"
      "template_overwrite" =&gt; true
    }
  }

}
          </pre>
<p>Once the data is ElasticSearch, you can easily create for example
      Grafana dashboard like:</p>
<table border="0" summary="manufactured viewport for HTML img" style="cellpadding: 0; cellspacing: 0;" width="100%"><tr><td><img src="images/grafana.png" width="100%"></td></tr></table>
</div>
<div class="section">
<div class="titlepage"><div><div><h3 class="title">
<a name="elk_stack_infrastructure"></a>6.7.3. A Pre-Configured Data Collection Pipeline</h3></div></div></div>
<p>In this <a class="ulink" href="https://github.com/pegasus-isi/dibbs-data-collection-setup" target="_top">
          <em class="citetitle">repository</em>
        </a>, we provide a containerized data-collection/visualization
      pipeline similar to what we use in production. The figure below
      illustrates the processes involved in the pipeline and how they are
      connected to one another. For more information regarding setup and
      usage, please visit the link referenced above.</p>
<table border="0" summary="manufactured viewport for HTML img" style="cellpadding: 0; cellspacing: 0;" width="100%"><tr><td><img src="images/data-collection-pipeline.svg" width="100%"></td></tr></table>
</div>
</div><div class="navfooter">
<hr>
<table width="100%" summary="Navigation footer">
<tr>
<td width="40%" align="left">
<a accesskey="p" href="stampede_wf_events.php">Prev</a> </td>
<td width="20%" align="center"><a accesskey="u" href="monitoring_debugging_stats.php">Up</a></td>
<td width="40%" align="right"> <a accesskey="n" href="execution_environments.php">Next</a>
</td>
</tr>
<tr>
<td width="40%" align="left" valign="top">6.6. Stampede Workflow Events </td>
<td width="20%" align="center"><a accesskey="h" href="index.php">Table of Contents</a></td>
<td width="40%" align="right" valign="top"> Chapter 7. Execution Environments</td>
</tr>
</table>
</div><?php  
            pegasus_footer();
        ?>
