<?php  
            require('/srv2/pegasus.isi.edu/includes/common.php'); 
            pegasus_header("7.5. Remote Cluster using PyGlidein");
        ?><div class="breadcrumbs">
<span class="breadcrumb-link"><a href="index.php">Pegasus 4.9.3 User Guide</a></span> &gt; <span class="breadcrumb-link"><a href="execution_environments.php">Execution Environments</a></span> &gt; <span class="breadcrumb-node">Remote Cluster using PyGlidein</span>
</div><hr><div class="section">
<div class="titlepage"><div><div><h2 class="title" style="clear: both">
<a name="pyglidein"></a>7.5. Remote Cluster using PyGlidein</h2></div></div></div>
<p>Glideins (HTCondor pilot jobs) provide an efficient solution for
    high-throughput workflows. The glideins are submitted to the remote
    cluster scheduler, and once started up, makes it appear like your HTCondor
    pool extends into the remote cluster. HTCondor can then schedule the jobs
    to the remote compute node in the same way it would schedule jobs to local
    compute nodes.</p>
<p>Some infrastructures, such as <a class="link" href="open_science_grid.php" title="7.14. Open Science Grid Using glideinWMS">Open
    Science Grid</a>, provide infrastructure level glidein solutions, such
    as GlideinWMS. Another solution is <a class="link" href="bosco.php" title="7.10. Remote PBS Cluster using BOSCO and SSH">BOSCO</a>. For
    some more custom setups, <a class="ulink" href="https://github.com/WIPACrepo/pyglidein" target="_top">pyglidein</a> from the
    <a class="ulink" href="http://icecube.wisc.edu/" target="_top">IceCube</a> project provides a
    nice framework. The architecture consists on a server on the submit host,
    which job it is to determining the demand. On the remote resource, the
    client can be invoked for example via cron, and submits directly to
    HTCondor, SLURM and PBS schedulers. This makes pyglidein very flexible and
    works well for example if the resource requires two-factor
    authentication.</p>
<div class="figure">
<a name="fig-pyglidein"></a><p class="title"><b>Figure 7.4. pyglidein overview</b></p>
<div class="figure-contents"><div class="mediaobject" align="center"><table border="0" summary="manufactured viewport for HTML img" style="cellpadding: 0; cellspacing: 0;" width="100%"><tr><td align="center" valign="middle"><img src="images/pyglidein.png" align="middle" height="360" alt="pyglidein overview"></td></tr></table></div></div>
</div>
<p><br class="figure-break"></p>
<p>To get started with pyglidein, check out a copy of the Git
    repository on both your submit host as well as the cluster you want to
    glidein to. Starting with the submit host, first make sure you have
    HTCondor configured for <a class="ulink" href="http://research.cs.wisc.edu/htcondor/manual/current/3_8Security.html#SECTION00483400000000000000" target="_top">PASSWORD</a>
    authentication. Make a copy of the HTCondor pool password file. You will
    need it later in the configuration, and it is a binary file, so make sure you cp
    instead of a copy-and-paste of the file contents.</p>
<p>Follow the installation instructions provided in the PyGlidein
    <a class="ulink" href="https://github.com/WIPACrepo/pyglidein" target="_top">repo</a>. Note that
    you can use virtualenv if you do not want to do a system-wide install:
    </p>
<pre class="programlisting">
$ module load python2   (might not be needed on your system) 
$ virtualenv pyglidein
New python executable in /home/user/pyglidein/bin/python
Installing setuptools, pip, wheel...done.
$ . pyglidein/bin/activate
$ pip install pyglidein
...
    </pre>
<p>Then, to get the server started:</p>
<pre class="programlisting">
pyglidein_server --port 22001  
    </pre>
<p>By default, the pyglidein server will use all jobs in the system to
    determine if glideins are needed. If you want user jobs to explicitly let
    us know they want glideins, you can pass a constraint for the server to
    use. For example, jobs could have the <span class="emphasis"><em>+WantPSCBridges =
    True</em></span> attribute, and then we could start the server with:</p>
<pre class="programlisting">
pyglidein_server --port 22001 --constraint "'WantPSCBridges == True'"  
    </pre>
<p>One the server is running, you can check status by pointing a web
    browser to it.</p>
<p>The client (running on the cluster you want glideins on), requires
    a few configuration files and a <span class="emphasis"><em>glidein.tar.gz</em></span> file
    containing the HTCondor binaries, our pool password file, and a modified
    job wrapper script. This <span class="emphasis"><em>glidein.tar.gz</em></span> file can 
    be created using the provided <span class="emphasis"><em>create_glidein_tarball.py</em></span>
    script, but an easier way is using the already prepared tarball from 
    <a class="ulink" href="" target="_top"></a> and injecting your pool password file. For example:
    </p>
<pre class="programlisting">
$ wget https://download.pegasus.isi.edu/pyglidein/glidein.tar.gz
$ mkdir glidein
$ cd glidein
$ tar xzf ../glidein.tar.gz
$ cp /some/path/to/poolpasswd passwdfile
$ tar czf ../glidein.tar.gz .
$ cd ..
$ rm -rf glidein
    </pre>
<p>You can serve this file over for example http, but as it now contains
    your pool password, we recommend you copy the <span class="emphasis"><em>glidein.tar.gz</em></span>
    to the remote cluster via scp.</p>
<p>Create a configuration file for your glidein. Here is an example for PSC
        Bridges (other config file examples available under configs/ in the PyGlidein
        GitHub repo):</p>
<pre class="programlisting">
[Mode]
debug = True

[Glidein]
address = http://workflow.isi.edu:22001/jsonrpc
site = PSC-Bridges
tarball = /home/rynge/pyglidein-config/glidein.tar.gz

[Cluster]
user = rynge
os = RHEL7
scheduler = slurm
max_idle_jobs = 1
limit_per_submit = 2
walltime_hrs = 48
partitions = RM

[RM]
gpu_only = False
whole_node = True
whole_node_memory = 120000
whole_node_cpus = 28
whole_node_disk = 8000000
whole_node_gpus = 0
partition = RM
group_jobs = False
submit_command = sbatch
running_cmd = squeue -u $USER -t RUNNING -h -p RM | wc -l
idle_cmd = squeue -u $USER -t PENDING -h -p RM | wc -l

[SubmitFile]
filename = submit.slurm
local_dir = $LOCAL
sbatch = #SBATCH
custom_header = #SBATCH -C EGRESS
    #SBATCH --account=ABC123
cvmfs_job_wrapper = False

[StartdLogging]
send_startd_logs = False
url = s3.amazonaws.com
bucket = pyglidein-logging-bridges

[StardChecks]
enable_startd_checks = True

[CustomEnv]
CLUSTER = workflow.isi.edu
    </pre>
<p>This configuration will obviously look different for different
    clusters. A few things to note:</p>
<div class="itemizedlist"><ul class="itemizedlist" style="list-style-type: disc; ">
<li class="listitem"><p><span class="bold"><strong>address</strong></span> is the location of the
        server we started earlier</p></li>
<li class="listitem"><p><span class="bold"><strong>tarball</strong></span> is the full path to our
        custom glidein.tar.gz file we created above.</p></li>
<li class="listitem"><p><span class="bold"><strong>CLUSTER</strong></span> is the location of your
        HTCondor central manager. In many cases this is the same host you
        started the server on. Please note that if you do not set this
        variable, the glideins will try to register into the IceCube
        infrastructure.</p></li>
<li class="listitem"><p><span class="bold"><strong>#SBATCH -C EGRESS</strong></span> is PSC Bridges
              specific and enables outbound network connectivity from the compute
              nodes.
        </p></li>
<li class="listitem"><p><span class="bold"><strong>#SBATCH --account=ABC123</strong></span> specifies
              which allocation to charge the job to. This is a required setting on 
              many, but not all, HPC systems. On PSC Bridges, you can get a list of
              your allocation by running the <span class="emphasis"><em>projects</em></span> command,
              and looking for the <span class="emphasis"><em>Charge ID</em></span> field.
        </p></li>
</ul></div>
<p>We also need <span class="emphasis"><em>secrets</em></span> file. We are not using any
        remote logging in this example, but the file still has to exist with the
        following content:
    </p>
<pre class="programlisting">
[StartdLogging]
access_key = 
secret_key =
    </pre>
<p>At this point we can try our first glidein:</p>
<pre class="programlisting">
pyglidein_client --config=bridges.config --secrets=secrets
    </pre>
<p>Once we have a seen a successful glidein, we can add the client to
    the crontab:</p>
<pre class="programlisting">
# m  h  dom mon dow   command
*/10 *   *   *   *    (cd ~/pyglidein/ &amp;&amp; pyglidein_client --config=bridges.config --secrets=secrets) &gt;~/cron-pyglidein.log 2&gt;&amp;1
    </pre>
<p>With this setup, glideins will now appear automatically based on the
    demand in the local HTCondor queue.</p>
</div><div class="navfooter">
<hr>
<table width="100%" summary="Navigation footer">
<tr>
<td width="40%" align="left">
<a accesskey="p" href="aws-batch.php">Prev</a> </td>
<td width="20%" align="center"><a accesskey="u" href="execution_environments.php">Up</a></td>
<td width="40%" align="right"> <a accesskey="n" href="globus_gram.php">Next</a>
</td>
</tr>
<tr>
<td width="40%" align="left" valign="top">7.4. Amazon AWS Batch </td>
<td width="20%" align="center"><a accesskey="h" href="index.php">Table of Contents</a></td>
<td width="40%" align="right" valign="top"> 7.6. Remote Cluster using Globus GRAM</td>
</tr>
</table>
</div><?php  
            pegasus_footer();
        ?>
