<?php  
            require('/srv2/pegasus.isi.edu/includes/common.php'); 
            pegasus_header("7.13. Titan Using Glite");
        ?><div class="breadcrumbs">
<span class="breadcrumb-link"><a href="index.php">Pegasus 4.9.3 User Guide</a></span> &gt; <span class="breadcrumb-link"><a href="execution_environments.php">Execution Environments</a></span> &gt; <span class="breadcrumb-node">Titan Using Glite</span>
</div><hr><div class="section">
<div class="titlepage"><div><div><h2 class="title" style="clear: both">
<a name="titan"></a>7.13. Titan Using Glite</h2></div></div></div>
<p>
    <a class="ulink" href="https://www.olcf.ornl.gov/olcf-resources/compute-systems/titan/" target="_top">Titan</a>
    is part of Oak Ridge Leadership Computing Facilities (OLCF) and offers hybrid computing
    resources (CPUs and GPUs) to scientists since 2012.
    </p>
<p>
    In order to submit to Titan, a <span class="emphasis"><em> Titan login node</em></span> or a system that has access
    to the <span class="emphasis"><em>Lustre</em></span> filesystem and the <span class="emphasis"><em>batch scheduler</em></span>
    (eg. <a class="ulink" href="https://www.olcf.ornl.gov/wp-content/uploads/2017/11/2018UM-Day3-Kincl.pdf" target="_top">OLCF's Kubernetes Deployment</a>),
    must be used as the submit node. Submission style must be
    <a class="ulink" href="https://pegasus.isi.edu/documentation/glite.php" target="_top">Pegasus Glite</a> and an example
    site calatog entry looks like this:

    </p>
<pre class="programlisting">
&lt;sitecatalog xmlns="http://pegasus.isi.edu/schema/sitecatalog"
            xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
            xsi:schemaLocation="http://pegasus.isi.edu/schema/sitecatalog http://pegasus.isi.edu/schema/sc-4.1.xsd"
            version="4.1"&gt;

    &lt;site handle="local" arch="x86_64" os="LINUX"&gt;
        &lt;directory type="shared-scratch" path="/lustre/atlas/scratch/user/workflow-dir/scratch"/&gt;
            &lt;file-server operation="all" url="file:///lustre/atlas/scratch/user/workflow-dir/scratch"/&gt;
        &lt;/directory&gt;
        &lt;directory type="shared-storage" path="/lustre/atlas/scratch/user/workflow-dir/output/"&gt;
            &lt;file-server operation="all" url="file:///lustre/atlas/scratch/user/workflow-dir/output"/&gt;
        &lt;/directory&gt;
    &lt;/site&gt;

    &lt;site handle="titan" arch="x86_64" os="LINUX"&gt;
        &lt;directory type="shared-scratch" path="/lustre/atlas/scratch/user/titan/scratch"&gt;
            &lt;file-server operation="all" url="file:///lustre/atlas/scratch/user/titan/scratch"/&gt;
        &lt;/directory&gt;

        &lt;profile namespace="pegasus" key="style"&gt;glite&lt;/profile&gt;
        &lt;profile namespace="condor" key="grid_resource"&gt;batch pbs&lt;/profile&gt;

        &lt;profile namespace="pegasus" key="queue"&gt;titan&lt;/profile&gt;
        &lt;profile namespace="pegasus" key="auxillary.local"&gt;true&lt;/profile&gt;

        &lt;profile namespace="env" key="PEGASUS_HOME"&gt;/lustre/atlas/world-shared/csc320/SOFTWARE/install/pegasus/default&lt;/profile&gt;
        &lt;profile namespace="pegasus" key="runtime"&gt;1800&lt;/profile&gt;
        &lt;profile namespace="pegasus" key="nodes"&gt;1&lt;/profile&gt;
        &lt;profile namespace="pegasus" key="project"&gt;CSC320&lt;/profile&gt;
    &lt;/site&gt;
&lt;/sitecatalog&gt;
    </pre>
<p>
    </p>
<p>
      </p>
<div class="orderedlist"><ol class="orderedlist" type="1">
<li class="listitem"><p><span class="emphasis"><em>pegasus</em></span> profile style with value set to <span class="emphasis"><em>glite</em></span></p></li>
<li class="listitem"><p><span class="emphasis"><em>condor</em></span> profile <span class="emphasis"><em>grid_resource</em></span> with value set to <span class="emphasis"><em>batch pbs</em></span></p></li>
<li class="listitem"><p><span class="emphasis"><em>pegasus</em></span> profile <span class="emphasis"><em>queue</em></span> is mandatory and should be set to <span class="emphasis"><em>titan</em></span></p></li>
<li class="listitem"><p><span class="emphasis"><em>pegasus</em></span> profile <span class="emphasis"><em>runtime</em></span> is mandatory and should be set in sites or transformation catalog</p></li>
<li class="listitem"><p><span class="emphasis"><em>pegasus</em></span> profile <span class="emphasis"><em>nodes</em></span> is mandatory and should be set in sites or transformation catalog</p></li>
<li class="listitem"><p><span class="emphasis"><em>pegasus</em></span> profile <span class="emphasis"><em>project</em></span> must be set to the project name your jobs run under</p></li>
</ol></div>
<p>
    </p>
<div class="note" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Note</h3>
<p>
    <span class="emphasis"><em>pegasus</em></span> profile <span class="emphasis"><em>cores</em></span> is incompatible with Titan's PBS submissions.
    </p>
</div>
</div><div class="navfooter">
<hr>
<table width="100%" summary="Navigation footer">
<tr>
<td width="40%" align="left">
<a accesskey="p" href="xsede.php">Prev</a> </td>
<td width="20%" align="center"><a accesskey="u" href="execution_environments.php">Up</a></td>
<td width="40%" align="right"> <a accesskey="n" href="open_science_grid.php">Next</a>
</td>
</tr>
<tr>
<td width="40%" align="left" valign="top">7.12. XSEDE </td>
<td width="20%" align="center"><a accesskey="h" href="index.php">Table of Contents</a></td>
<td width="40%" align="right" valign="top"> 7.14. Open Science Grid Using glideinWMS</td>
</tr>
</table>
</div><?php  
            pegasus_footer();
        ?>
