<?php  
            require('/srv2/pegasus.isi.edu/includes/common.php'); 
            pegasus_header("10.2. Data Transfers");
        ?><div class="breadcrumbs">
<span class="breadcrumb-link"><a href="index.php">Pegasus 4.9.3 User Guide</a></span> &gt; <span class="breadcrumb-link"><a href="data_management.php">Data Management</a></span> &gt; <span class="breadcrumb-node">Data Transfers</span>
</div><hr><div class="section">
<div class="titlepage"><div><div><h2 class="title" style="clear: both">
<a name="transfer"></a>10.2. Data Transfers</h2></div></div></div>
<div class="toc"><dl class="toc">
<dt><span class="section"><a href="transfer.php#ref_data_staging_configuration">10.2.1. Data Staging Configuration</a></span></dt>
<dt><span class="section"><a href="transfer.php#local_vs_remote_transfers">10.2.2. Local versus Remote Transfers</a></span></dt>
<dt><span class="section"><a href="transfer.php#controlling_transfer_parallelism">10.2.3. Controlling Transfer Parallelism</a></span></dt>
<dt><span class="section"><a href="transfer.php#transfer_symlink">10.2.4. Symlinking Against Input Data</a></span></dt>
<dt><span class="section"><a href="transfer.php#data_movement_nodes">10.2.5. Addition of Separate Data Movement Nodes to Executable
      Workflow</a></span></dt>
<dt><span class="section"><a href="transfer.php#idm4843">10.2.6. Staging of Executables</a></span></dt>
<dt><span class="section"><a href="transfer.php#transfer_worker_package_staging">10.2.7. Staging of Worker Package</a></span></dt>
<dt><span class="section"><a href="transfer.php#container-transfers">10.2.8. Staging of Application Containers</a></span></dt>
<dt><span class="section"><a href="transfer.php#staging_job_checkpoint_files">10.2.9. Staging of Job Checkpoint Files</a></span></dt>
</dl></div>
<p>As part of the Workflow Mapping Process, Pegasus does data
    management for the executable workflow . It queries a Replica Catalog to
    discover the locations of the input datasets and adds data movement and
    registration nodes in the workflow to</p>
<div class="orderedlist"><ol class="orderedlist" type="1">
<li class="listitem"><p>stage-in input data to the staging sites ( a site associated
        with the compute job to be used for staging. In the shared filesystem
        setup, staging site is the same as the execution sites where the jobs
        in the workflow are executed )</p></li>
<li class="listitem"><p>stage-out output data generated by the workflow to the final
        storage site.</p></li>
<li class="listitem"><p>stage-in intermediate data between compute sites if
        required.</p></li>
<li class="listitem"><p>data registration nodes to catalog the locations of the output
        data on the final storage site into the replica catalog.</p></li>
</ol></div>
<p>The separate data movement jobs that are added to the executable
    workflow are responsible for staging data to a workflow specific directory
    accessible to the staging server on a staging site associated with the
    compute sites. Depending on the data staging configuration, the staging
    site for a compute site is the compute site itself. In the default case,
    the staging server is usually on the headnode of the compute site and has
    access to the shared filesystem between the worker nodes and the head
    node. Pegasus adds a directory creation job in the executable workflow
    that creates the workflow specific directory on the staging server.</p>
<p>In addition to data, Pegasus will transfer user executables to the
    compute sites if the executables are not installed on the remote sites
    before hand. This chapter gives an overview of how the transfers of data and
    executables are managed in Pegasus.</p>
<p>Pegasus picks up files for data transfers based on the transfer
    attribute associated with the input and output files for the job. These
    are designated in the DAX as uses elements in the job element. If not
    specified, the transfer flag defaults to true. So if you don't want all
    the generated files to be transferred to the output site, you need to
    explicitly set the transfer flag to false for the file.</p>
<pre class="programlisting">
  &lt;!-- snippet of job description --&gt;
  &lt;job id="ID000001" namespace="example" name="mDiffFit" version="1.0"
       node-label="preprocess" &gt;
    &lt;argument&gt;-a top -T 6  -i &lt;file name="f.a"/&gt;  -o &lt;file name="f.b1"/&gt;&lt;/argument&gt;

     &lt;uses name="f.a" link="input" transfer="true" register="true"/&gt;
     &lt;!-- tells Pegasus to not transfer the output file f.b to the output site --&gt;
     &lt;uses name="f.b" link="output" transfer="false" register="false"  /&gt;
     ...
  &lt;/job&gt;</pre>
<div class="section">
<div class="titlepage"><div><div><h3 class="title">
<a name="ref_data_staging_configuration"></a>10.2.1. Data Staging Configuration</h3></div></div></div>
<p>Pegasus can be broadly setup to run workflows in the following
      configurations</p>
<div class="itemizedlist"><ul class="itemizedlist" style="list-style-type: disc; ">
<li class="listitem">
<p><span class="bold"><strong>Shared File System</strong></span></p>
<p>This setup applies to where the head node and the worker nodes
          of a cluster share a filesystem. Compute jobs in the workflow run in
          a directory on the shared filesystem.</p>
</li>
<li class="listitem">
<p><span class="bold"><strong>NonShared FileSystem</strong></span></p>
<p>This setup applies to where the head node and the worker nodes
          of a cluster don't share a filesystem. Compute jobs in the workflow
          run in a local directory on the worker node</p>
</li>
<li class="listitem">
<p><span class="bold"><strong>Condor Pool Without a shared
          filesystem</strong></span></p>
<p>This setup applies to a condor pool where the worker nodes
          making up a condor pool don't share a filesystem. All data IO is
          achieved using Condor File IO. This is a special case of the non
          shared filesystem setup, where instead of using pegasus-transfer to
          transfer input and output data, Condor File IO is used.</p>
</li>
</ul></div>
<p>For the purposes of data configuration various sites, and
      directories are defined below.</p>
<div class="orderedlist"><ol class="orderedlist" type="1">
<li class="listitem">
<p><span class="bold"><strong>Submit Host</strong></span></p>
<p>The host from where the workflows are submitted . This is
          where Pegasus and Condor DAGMan are installed. This is referred to
          as the <span class="bold"><strong>"local"</strong></span> site in the site
          catalog .</p>
</li>
<li class="listitem">
<p><span class="bold"><strong>Compute Site</strong></span></p>
<p>The site where the jobs mentioned in the DAX are executed.
          There needs to be an entry in the Site Catalog for every compute
          site. The compute site is passed to pegasus-plan using <span class="bold"><strong>--sites</strong></span> option</p>
</li>
<li class="listitem">
<p><span class="bold"><strong>Staging Site</strong></span></p>
<p>A site to which the separate transfer jobs in the executable
          workflow ( jobs with stage_in , stage_out and stage_inter prefixes
          that Pegasus adds using the transfer refiners) stage the input data
          to and the output data from to transfer to the final output site.
          Currently, the staging site is always the compute site where the
          jobs execute.</p>
</li>
<li class="listitem">
<p><span class="bold"><strong>Output Site</strong></span></p>
<p>The output site is the final storage site where the users want
          the output data from jobs to go to. The output site is passed to
          pegasus-plan using the <span class="bold"><strong>--output</strong></span>
          option. The stageout jobs in the workflow stage the data from the
          staging site to the final storage site.</p>
</li>
<li class="listitem">
<p><span class="bold"><strong>Input Site</strong></span></p>
<p>The site where the input data is stored. The locations of the
          input data are catalogued in the Replica Catalog, and the
          <span class="emphasis"><em>"site"</em></span> attribute of the locations gives us the
          site handle for the input site.</p>
</li>
<li class="listitem">
<p><span class="bold"><strong>Workflow Execution
          Directory</strong></span></p>
<p>This is the directory created by the create dir jobs in the
          executable workflow on the Staging Site. This is a directory per
          workflow per staging site. Currently, the Staging site is always the
          Compute Site.</p>
</li>
<li class="listitem">
<p><span class="bold"><strong>Worker Node Directory</strong></span></p>
<p>This is the directory created on the worker nodes per job
          usually by the job wrapper that launches the job.</p>
</li>
</ol></div>
<div class="section">
<div class="titlepage"><div><div><h4 class="title">
<a name="idm4593"></a>10.2.1.1. Shared File System</h4></div></div></div>
<p>By default Pegasus is setup to run workflows in the shared file
        system setup, where the worker nodes and the head node of a cluster
        share a filesystem.</p>
<div class="figure">
<a name="idm4596"></a><p class="title"><b>Figure 10.1. Shared File System Setup</b></p>
<div class="figure-contents"><div class="mediaobject" align="center"><img src="images/data-configuration-sharedfs.png" align="middle" height="450" alt="Shared File System Setup"></div></div>
</div>
<br class="figure-break"><p>The data flow is as follows in this case</p>
<div class="orderedlist"><ol class="orderedlist" type="1">
<li class="listitem"><p>Stagein Job executes ( either on Submit Host or Head Node )
            to stage in input data from Input Sites ( 1---n) to a workflow
            specific execution directory on the shared filesystem.</p></li>
<li class="listitem"><p>Compute Job starts on a worker node in the workflow
            execution directory. Accesses the input data using Posix IO</p></li>
<li class="listitem"><p>Compute Job executes on the worker node and writes out
            output data to workflow execution directory using Posix IO</p></li>
<li class="listitem"><p>Stageout Job executes ( either on Submit Host or Head Node )
            to stage out output data from the workflow specific execution
            directory to a directory on the final output site.</p></li>
</ol></div>
<div class="tip" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Tip</h3>
<p>Set <span class="bold"><strong>
          pegasus.data.configuration</strong></span> to <span class="bold"><strong>
          sharedfs</strong></span> to run in this configuration.</p>
</div>
</div>
<div class="section">
<div class="titlepage"><div><div><h4 class="title">
<a name="idm4617"></a>10.2.1.2. Non Shared Filesystem</h4></div></div></div>
<p>In this setup , Pegasus runs workflows on local file-systems of
        worker nodes with the the worker nodes not sharing a filesystem. The
        data transfers happen between the worker node and a staging / data
        coordination site. The staging site server can be a file server on the
        head node of a cluster or can be on a separate machine.</p>
<p><span class="bold"><strong>Setup</strong></span> </p>
<div class="itemizedlist"><ul class="itemizedlist" style="list-style-type: disc; ">
<li class="listitem"><p>compute and staging site are the different</p></li>
<li class="listitem"><p>head node and worker nodes of compute site don't share a
              filesystem</p></li>
<li class="listitem"><p>Input Data is staged from remote sites.</p></li>
<li class="listitem"><p>Remote Output Site i.e site other than compute site. Can
              be submit host.</p></li>
</ul></div>
<div class="figure">
<a name="idm4631"></a><p class="title"><b>Figure 10.2. Non Shared Filesystem Setup</b></p>
<div class="figure-contents"><div class="mediaobject" align="center">
<a name="Figure2"></a><img src="images/data-configuration-nonsharedfs.png" align="middle" height="450" alt="Non Shared Filesystem Setup">
</div></div>
</div>
<br class="figure-break"><p>The data flow is as follows in this case</p>
<div class="orderedlist"><ol class="orderedlist" type="1">
<li class="listitem"><p>Stagein Job executes ( either on Submit Host or on staging
            site ) to stage in input data from Input Sites ( 1---n) to a
            workflow specific execution directory on the staging site.</p></li>
<li class="listitem"><p>Compute Job starts on a worker node in a local execution
            directory. Accesses the input data using pegasus transfer to
            transfer the data from the staging site to a local directory on
            the worker node</p></li>
<li class="listitem"><p>The compute job executes in the worker node, and executes on
            the worker node.</p></li>
<li class="listitem"><p>The compute Job writes out output data to the local
            directory on the worker node using Posix IO</p></li>
<li class="listitem"><p>Output Data is pushed out to the staging site from the
            worker node using pegasus-transfer.</p></li>
<li class="listitem"><p>Stageout Job executes ( either on Submit Host or staging
            site ) to stage out output data from the workflow specific
            execution directory to a directory on the final output
            site.</p></li>
</ol></div>
<p>In this case, the compute jobs are wrapped as <a class="link" href="pegasuslite.php" title="5.4. PegasusLite">PegasusLite</a> instances.</p>
<p>This mode is especially useful for running in the cloud
        environments where you don't want to setup a shared filesystem between
        the worker nodes. Running in that mode is explained in detail <a class="link" href="cloud.php#amazon_aws" title="7.3.1. Amazon EC2">here.</a></p>
<div class="tip" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Tip</h3>
<p>Set p <span class="bold"><strong>egasus.data.configuration</strong></span> to <span class="bold"><strong>nonsharedfs</strong></span> to run in this configuration. The
          staging site can be specified using the <span class="bold"><strong>--staging-site</strong></span> option to pegasus-plan.</p>
</div>
<p>In this setup, Pegasus always stages the input files through the
        staging site i.e the stage-in job stages in data from the input site
        to the staging site. The PegasusLite jobs that start up on the worker
        nodes, then pull the input data from the staging site for each job. In
        some cases, it might be useful to setup the PegasusLite jobs to pull
        input data directly from the input site without going through the
        staging server. This is based on the assumption that the worker nodes
        can access the input site. Starting 4.3 release, users can enable
        this. However, you should be aware that the access to the input site
        is no longer throttled ( as in case of stage in jobs). If large number
        of compute jobs start at the same time in a workflow, the input server
        will see a connection from each job.</p>
<div class="tip" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Tip</h3>
<p>Set <span class="bold"><strong>
          pegasus.transfer.bypass.input.staging</strong></span> to <span class="bold"><strong>true</strong></span>to enable the bypass of staging of input
          files via the staging server.</p>
</div>
</div>
<div class="section">
<div class="titlepage"><div><div><h4 class="title">
<a name="idm4666"></a>10.2.1.3. Condor Pool Without a Shared Filesystem</h4></div></div></div>
<p>This setup applies to a condor pool where the worker nodes
        making up a condor pool don't share a filesystem. All data IO is
        achieved using Condor File IO. This is a special case of the non
        shared filesystem setup, where instead of using pegasus-transfer to
        transfer input and output data, Condor File IO is used.</p>
<p><span class="bold"><strong>Setup</strong></span> </p>
<div class="itemizedlist"><ul class="itemizedlist" style="list-style-type: disc; ">
<li class="listitem"><p>Submit Host and staging site are same</p></li>
<li class="listitem"><p>head node and worker nodes of compute site don't share a
              filesystem</p></li>
<li class="listitem"><p>Input Data is staged from remote sites.</p></li>
<li class="listitem"><p>Remote Output Site i.e site other than compute site. Can
              be submit host.</p></li>
</ul></div>
<div class="figure">
<a name="idm4680"></a><p class="title"><b>Figure 10.3. Condor Pool Without a Shared Filesystem</b></p>
<div class="figure-contents"><div class="mediaobject" align="center">
<a name="Figure13"></a><img src="images/data-configuration-condorio.png" align="middle" height="450" alt="Condor Pool Without a Shared Filesystem">
</div></div>
</div>
<br class="figure-break"><p>The data flow is as follows in this case</p>
<div class="orderedlist"><ol class="orderedlist" type="1">
<li class="listitem"><p>Stagein Job executes on the submit host to stage in input
            data from Input Sites ( 1---n) to a workflow specific execution
            directory on the submit host</p></li>
<li class="listitem"><p>Compute Job starts on a worker node in a local execution
            directory. Before the compute job starts, Condor transfers the
            input data for the job from the workflow execution directory on
            thesubmit host to the local execution directory on the worker
            node.</p></li>
<li class="listitem"><p>The compute job executes in the worker node, and executes on
            the worker node.</p></li>
<li class="listitem"><p>The compute Job writes out output data to the local
            directory on the worker node using Posix IO</p></li>
<li class="listitem"><p>When the compute job finishes, Condor transfers the output
            data for the job from the local execution directory on the worker
            node to the workflow execution directory on the submit
            host.</p></li>
<li class="listitem"><p>Stageout Job executes ( either on Submit Host or staging
            site ) to stage out output data from the workflow specific
            execution directory to a directory on the final output
            site.</p></li>
</ol></div>
<p>In this case, the compute jobs are wrapped as <a class="link" href="pegasuslite.php" title="5.4. PegasusLite">PegasusLite</a> instances.</p>
<p>This mode is especially useful for running in the cloud
        environments where you don't want to setup a shared filesystem between
        the worker nodes. Running in that mode is explained in detail <a class="link" href="cloud.php#amazon_aws" title="7.3.1. Amazon EC2">here.</a></p>
<div class="tip" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Tip</h3>
<p>Set <span class="bold"><strong>pegasus.data.configuration</strong></span> to <span class="bold"><strong>condorio</strong></span> to run in this configuration. In
          this mode, the staging site is automatically set to site <span class="bold"><strong>local</strong></span></p>
</div>
<p>In this setup, Pegasus always stages the input files through the
        submit host i.e the stage-in job stages in data from the input site to
        the submit host (local site). The input data is then transferred to
        remote worker nodes from the submit host using Condor file transfers.
        In the case, where the input data is locally accessible at the submit
        host i.e the input site and the submit host are the same, then it is
        possible to bypass the creation of separate stage in jobs that copy
        the data to the workflow specific directory on the submit host.
        Instead, Condor file transfers can be setup to transfer the input
        files directly from the locally accessible input locations ( file
        URL's with "<span class="emphasis"><em>site</em></span>" attribute set to local)
        specified in the replica catalog. Starting 4.3 release, users can
        enable this.</p>
<div class="tip" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Tip</h3>
<p>Set <span class="bold"><strong>
          pegasus.transfer.bypass.input.staging</strong></span> to <span class="bold"><strong>true</strong></span>to bypass the creation of separate stage
          in jobs.</p>
</div>
</div>
</div>
<div class="section">
<div class="titlepage"><div><div><h3 class="title">
<a name="local_vs_remote_transfers"></a>10.2.2. Local versus Remote Transfers</h3></div></div></div>
<p>As far as possible, Pegasus will ensure that the transfer jobs
      added to the executable workflow are executed on the submit host. By
      default, Pegasus will schedule a transfer to be executed on the remote
      staging site only if there is no way to execute it on the submit host.
      Some scenarios where transfer jobs are executed on remote sites are as
      follows:</p>
<div class="itemizedlist"><ul class="itemizedlist" style="list-style-type: disc; ">
<li class="listitem"><p>the file server specified for the staging site/compute site is
          a file server. In that case, Pegasus will schedule all the stage in
          data movement jobs on the compute site to stage-in the input data
          for the workflow.</p></li>
<li class="listitem"><p>a user has symlinking turned on. In that case, the transfer
          jobs that symlink against the input data on the compute site, will
          be executed remotely ( on the compute site ).</p></li>
</ul></div>
<p>In certain execution environments, such a local campus cluster the
      compute site and the local share a filesystem ( i.e. compute site has
      file servers specified for the staging/compute site, and the scratch and
      storage directories mentioned for the compute site are locally mounted
      on the submit host), it is beneficial to have the remote transfer jobs
      run locally and hence bypass going through the local scheduler queue. In
      that case, users can set a boolean profile auxillary.local in pegasus
      namespace in the site catalog for the compute/staging site to
      true.</p>
<p>Users can specify the property <span class="bold"><strong>
      pegasus.transfer.*.remote.sites</strong></span> to change the default
      behaviour of Pegasus and force pegasus to run different types of
      transfer jobs for the sites specified on the remote site. The value of
      the property is a comma separated list of compute sites for which you
      want the transfer jobs to run remotely.</p>
<p>The table below illustrates all the possible variations of the
      property.</p>
<div class="table">
<a name="idm4728"></a><p class="title"><b>Table 10.1. Property Variations for pegasus.transfer.*.remote.sites</b></p>
<div class="table-contents"><table class="table" summary="Property Variations for pegasus.transfer.*.remote.sites" border="1">
<colgroup>
<col>
<col>
</colgroup>
<thead><tr>
<th>Property Name</th>
<th>Applies to</th>
</tr></thead>
<tbody>
<tr>
<td>pegasus.transfer.stagein.remote.sites</td>
<td>the stage in transfer jobs</td>
</tr>
<tr>
<td>pegasus.transfer.stageout.remote.sites</td>
<td>the stage out transfer jobs</td>
</tr>
<tr>
<td>pegasus.transfer.inter.remote.sites</td>
<td>the inter site transfer jobs</td>
</tr>
<tr>
<td>pegasus.transfer.*.remote.sites</td>
<td>all types of transfer jobs</td>
</tr>
</tbody>
</table></div>
</div>
<br class="table-break"><p>The prefix for the transfer job name indicates whether the
      transfer job is to be executed locallly ( on the submit host ) or
      remotely ( on the compute site ). For example stage_in_local_ in a
      transfer job name stage_in_local_isi_viz_0 indicates that the transfer
      job is a stage in transfer job that is executed locally and is used to
      transfer input data to compute site isi_viz. The prefix naming scheme
      for the transfer jobs is <span class="bold"><strong>
      [stage_in|stage_out|inter]_[local|remote]_</strong></span> .</p>
</div>
<div class="section">
<div class="titlepage"><div><div><h3 class="title">
<a name="controlling_transfer_parallelism"></a>10.2.3. Controlling Transfer Parallelism</h3></div></div></div>
<p>When it comes to data transfers, Pegasus ships with a default
      configuration which is trying to strike a balance between performance
      and aggressiveness. We obviously want data transfers to be as quick as
      possibly, but we also do not want our transfers to overwhelm data
      services and systems.</p>
<p>Starting 4.8.0 release, the default configuration of Pegasus now
      adds transfer jobs and cleanup jobs based on the number of jobs at a
      particular level of the workflow. For example, for every 10 compute jobs
      on a level of a workflow, one data transfer job( stage-in and stage-out)
      is created. The default configuration also sets how many threads such a
      pegasus-transfer job can spawn. Cleanup jobs are similarly constructed
      with an internal ratio of 5.</p>
<p>Information on how to control the number of stagein and stageout
      jobs can be found in the <a class="link" href="transfer.php#data_movement_nodes" title="10.2.5. Addition of Separate Data Movement Nodes to Executable Workflow"> Data
      Movement Nodes</a> section.</p>
<p>How to control the number of threads pegasus-transfer can use
      depends on if you want to control standard transfer jobs, or
      PegasusLite. For the former, see the <a class="link" href="properties.php#transfer_props" title="13.3.9. Transfer Configuration Properties">
      pegasus.transfer.threads</a> property, and for the latter the <a class="link" href="properties.php#transfer_props" title="13.3.9. Transfer Configuration Properties"> pegasus.transfer.lite.threads</a>
      property.</p>
</div>
<div class="section">
<div class="titlepage"><div><div><h3 class="title">
<a name="transfer_symlink"></a>10.2.4. Symlinking Against Input Data</h3></div></div></div>
<p>If input data for a job already exists on a compute site, then it
      is possible for Pegasus to symlink against that data. In this case, the
      remote stage in transfer jobs that Pegasus adds to the executable
      workflow will symlink instead of doing a copy of the data.</p>
<p>Pegasus determines whether a file is on the same site as the
      compute site, by inspecting the <span class="emphasis"><em>"site</em></span>" attribute
      associated with the URL in the Replica Catalog. If the
      <span class="emphasis"><em>"site"</em></span> attribute of an input file location matches
      the compute site where the job is scheduled, then that particular input
      file is a candidate for symlinking.</p>
<p>For Pegasus to symlink against existing input data on a compute
      site, following must be true</p>
<div class="orderedlist"><ol class="orderedlist" type="1">
<li class="listitem"><p>Property <span class="bold"><strong>
          pegasus.transfer.links</strong></span> is set to <span class="bold"><strong>
          true</strong></span></p></li>
<li class="listitem"><p>The input file location in the Replica Catalog has the
          <span class="emphasis"><em>"site"</em></span> attribute matching the compute
          site.</p></li>
</ol></div>
<div class="tip" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Tip</h3>
<p>To confirm if a particular input file is symlinked instead of
        being copied, look for the destination URL for that file in
        stage_in_remote*.in file. The destination URL will start with
        symlink:// .</p>
</div>
<p>In the symlinking case, Pegasus strips out URL prefix from a URL
      and replaces it with a file URL.</p>
<p>For example if a user has the following URL catalogued in the
      Replica Catalog for an input file f.input</p>
<pre class="programlisting">f.input   gsiftp://server.isi.edu/shared/storage/input/data/f.input site="isi"</pre>
<p>and the compute job that requires this file executes on a compute
      site named isi , then if symlinking is turned on the data stage in job
      (stage_in_remote_viz_0 ) will have the following source and destination
      specified for the file</p>
<pre class="programlisting">#viz viz
file:///shared/storage/input/data/f.input  symlink://shared-scratch/workflow-exec-dir/f.input
</pre>
</div>
<div class="section">
<div class="titlepage"><div><div><h3 class="title">
<a name="data_movement_nodes"></a>10.2.5. Addition of Separate Data Movement Nodes to Executable
      Workflow</h3></div></div></div>
<p>Pegasus relies on a Transfer Refiner that comes up with the
      strategy on how many data movement nodes are added to the executable
      workflow. All the compute jobs scheduled to a site share the same
      workflow specific directory. The transfer refiners ensure that only one
      copy of the input data is transferred to the workflow execution
      directory. This is to prevent data clobbering . Data clobbering can
      occur when compute jobs of a workflow share some input files, and have
      different stage in transfer jobs associated with them that are staging
      the shared files to the same destination workflow execution
      directory.</p>
<p>Pegasus supports three different transfer refiners that dictate
      how the stagein and stageout jobs are added for the workflow.The default
      Transfer Refiner used in Pegasus is the BalancedCluster Refiner.
      Starting 4.8.0 release, the default configuration of Pegasus now adds
      transfer jobs and cleanup jobs based on the number of jobs at a
      particular level of the workflow. For example, for every 10 compute jobs
      on a level of a workflow, one data transfer job( stage-in and stage-out)
      is created.</p>
<p>The transfer refiners also allow the user to specify how many
      local|remote stagein|stageout jobs are created per execution
      site.</p>
<p>The behavior of the refiners (BalancedCluster and Cluster) are
      controlled by specifying certain pegasus profiles</p>
<div class="orderedlist"><ol class="orderedlist" type="1">
<li class="listitem"><p>either with the execution sites in the site catalog</p></li>
<li class="listitem"><p>OR globally in the properties file</p></li>
</ol></div>
<div class="table">
<a name="idm4792"></a><p class="title"><b>Table 10.2. Pegasus Profile Keys For the Cluster Transfer Refiner</b></p>
<div class="table-contents"><table class="table" summary="Pegasus Profile Keys For the Cluster Transfer Refiner" border="1">
<colgroup>
<col>
<col>
</colgroup>
<thead><tr>
<th>Profile Key</th>
<th>Description</th>
</tr></thead>
<tbody>
<tr>
<td>stagein.clusters</td>
<td>This key determines the maximum number of stage-in jobs
              that are can executed locally or remotely per compute site per
              workflow.</td>
</tr>
<tr>
<td>stagein.local.clusters</td>
<td>This key provides finer grained control in determining
              the number of stage-in jobs that are executed locally and are
              responsible for staging data to a particular remote
              site.</td>
</tr>
<tr>
<td>stagein.remote.clusters</td>
<td>This key provides finer grained control in determining
              the number of stage-in jobs that are executed remotely on the
              remote site and are responsible for staging data to it.</td>
</tr>
<tr>
<td>stageout.clusters</td>
<td>This key determines the maximum number of stage-out jobs
              that are can executed locally or remotely per compute site per
              workflow.</td>
</tr>
<tr>
<td>stageout.local.clusters</td>
<td>This key provides finer grained control in determining
              the number of stage-out jobs that are executed locally and are
              responsible for staging data from a particular remote
              site.</td>
</tr>
<tr>
<td>stageout.remote.clusters</td>
<td>This key provides finer grained control in determining
              the number of stage-out jobs that are executed remotely on the
              remote site and are responsible for staging data from
              it.</td>
</tr>
</tbody>
</table></div>
</div>
<br class="table-break"><div class="tip" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Tip</h3>
<p>Which transfer refiner to use is controlled by property
        pegasus.transfer.refiner</p>
</div>
<div class="section">
<div class="titlepage"><div><div><h4 class="title">
<a name="transfer-refiner-balanced-cluster"></a>10.2.5.1. BalancedCluster</h4></div></div></div>
<p>This is a new transfer refiner that was introduced in Pegasus
        4.4.0 and is the default one used in Pegasus. It does a round robin
        distribution of the files amongst the stagein and stageout jobs per
        level of the workflow. The figure below illustrates the behavior of
        this transfer refiner.</p>
<div class="figure">
<a name="idm4823"></a><p class="title"><b>Figure 10.4. BalancedCluster Transfer Refiner : Input Data To Workflow
          Specific Directory on Shared File System</b></p>
<div class="figure-contents"><div class="mediaobject" align="center">
<a name="img-balanced-cluster-transfer-refiner"></a><img src="images/balanced-cluster-transfer-refiner.png" align="middle" height="650" alt="BalancedCluster Transfer Refiner : Input Data To Workflow Specific Directory on Shared File System">
</div></div>
</div>
<br class="figure-break">
</div>
<div class="section">
<div class="titlepage"><div><div><h4 class="title">
<a name="idm4830"></a>10.2.5.2. Cluster</h4></div></div></div>
<p>This transfer refiner is similar to BalancedCluster but differs
        in the way how distribution of files happen across stagein and
        stageout jobs per level of the workflow. In this refiner, all the
        input files for a job get associated with a single transfer job. As
        illustrated in the figure below each compute usually gets associated
        with one stagein transfer job. In contrast, for the BalancedCluster a
        compute job maybe associated with multiple data stagein jobs.</p>
<div class="figure">
<a name="idm4833"></a><p class="title"><b>Figure 10.5. Cluster Transfer Refiner : Input Data To Workflow Specific
          Directory on Shared File System</b></p>
<div class="figure-contents"><div class="mediaobject" align="center">
<a name="img-cluster-transfer-refiner"></a><img src="images/cluster-transfer-refiner.png" align="middle" height="650" alt="Cluster Transfer Refiner : Input Data To Workflow Specific Directory on Shared File System">
</div></div>
</div>
<br class="figure-break">
</div>
<div class="section">
<div class="titlepage"><div><div><h4 class="title">
<a name="idm4840"></a>10.2.5.3. Basic</h4></div></div></div>
<p>Pegasus also supports a basic Transfer Refiner that adds one
        stagein and stageout job per compute job of the workflow. This is not
        recommended to be used for large workflows as the number of data
        transfer nodes in the worst case are 2n where n is the number of
        compute jobs in the workflow.</p>
</div>
</div>
<div class="section">
<div class="titlepage"><div><div><h3 class="title">
<a name="idm4843"></a>10.2.6. Staging of Executables</h3></div></div></div>
<p>Users can get Pegasus to stage the user executable ( executable
      that the jobs in the DAX refer to ) as part of the transfer jobs to the
      workflow specific execution directory on the compute site. The URL
      locations of the executable need to be specified in the transformation
      catalog as the PFN and the type of executable needs to be set to
      <span class="bold"><strong> STAGEABLE</strong></span> .</p>
<p>The location of a transformation can be specified either in</p>
<div class="itemizedlist"><ul class="itemizedlist" style="list-style-type: disc; ">
<li class="listitem"><p>DAX in the executable section. More details <a class="link" href="api.php#dax_transformation_catalog" title="16.1.1.4.. The Transformation Catalog Section">here</a> .</p></li>
<li class="listitem"><p>Transformation Catalog. More details <a class="link" href="transformation.php" title="4.4. Executable Discovery (Transformation Catalog)">here</a> .</p></li>
</ul></div>
<p>A particular transformation catalog entry of type STAGEABLE is
      compatible with a compute site only if all the System Information
      attributes associated with the entry match with the System Information
      attributes for the compute site in the Site Catalog. The following
      attributes make up the System Information attributes</p>
<div class="orderedlist"><ol class="orderedlist" type="1">
<li class="listitem"><p>arch</p></li>
<li class="listitem"><p>os</p></li>
<li class="listitem"><p>osrelease</p></li>
<li class="listitem"><p>osversion</p></li>
</ol></div>
<div class="section">
<div class="titlepage"><div><div><h4 class="title">
<a name="idm4865"></a>10.2.6.1. Transformation Mappers</h4></div></div></div>
<p>Pegasus has a notion of transformation mappers that determines
        what type of executable are picked up when a job is executed on a
        remote compute site. For transfer of executable, Pegasus constructs a
        soft state map that resides on top of the transformation catalog, that
        helps in determining the locations from where an executable can be
        staged to the remote site.</p>
<p>Users can specify the following property to pick up a specific
        transformation mapper</p>
<pre class="programlisting"><span class="bold"><strong>pegasus.catalog.transformation.mapper</strong></span> </pre>
<p>Currently, the following transformation mappers are
        supported.</p>
<div class="table">
<a name="idm4872"></a><p class="title"><b>Table 10.3. Transformation Mappers Supported in Pegasus</b></p>
<div class="table-contents"><table class="table" summary="Transformation Mappers Supported in Pegasus" border="1">
<colgroup>
<col>
<col>
</colgroup>
<thead><tr>
<th>Transformation Mapper</th>
<th>Description</th>
</tr></thead>
<tbody>
<tr>
<td>Installed</td>
<td>This mapper only relies on transformation catalog
                entries that are of type INSTALLED to construct the soft state
                map. This results in Pegasus never doing any transfer of
                executable as part of the workflow. It always prefers the
                installed executable at the remote sites</td>
</tr>
<tr>
<td>Staged</td>
<td>This mapper only relies on matching transformation
                catalog entries that are of type STAGEABLE to construct the
                soft state map. This results in the executable workflow
                referring only to the staged executable, irrespective of the
                fact that the executable are already installed at the remote
                end</td>
</tr>
<tr>
<td>All</td>
<td>This mapper relies on all matching transformation
                catalog entries of type STAGEABLE or INSTALLED for a
                particular transformation as valid sources for the transfer of
                executable. This the most general mode, and results in the
                constructing the map as a result of the cartesian product of
                the matches.</td>
</tr>
<tr>
<td>Submit</td>
<td>This mapper only on matching transformation catalog
                entries that are of type STAGEABLE and reside at the submit
                host (site local), are used while constructing the soft state
                map. This is especially helpful, when the user wants to use
                the latest compute code for his computations on the grid and
                that relies on his submit host.</td>
</tr>
</tbody>
</table></div>
</div>
<br class="table-break">
</div>
</div>
<div class="section">
<div class="titlepage"><div><div><h3 class="title">
<a name="transfer_worker_package_staging"></a>10.2.7. Staging of Worker Package</h3></div></div></div>
<p>The worker package contains runtime tools such as
      <span class="emphasis"><em>pegasus-kickstart</em></span> and
      <span class="emphasis"><em>pegasus-transfer</em></span>, and is required to be available
      for most jobs.</p>
<p>How the package is made available to the jobs depends on multiple
      factors. For example, a pre-installed Pegasus can be used if the
      location is set using the environment profile PEGASUS_HOME for the site
      in the Site Catalog.</p>
<p>If Pegasus is not already available on the execution site, the
      worker package can be staged by setting the following property:</p>
<pre class="programlisting"><span class="bold"><strong>pegasus.transfer.worker.package          true</strong></span> </pre>
<p>Note that how the package is transferred and accessed differs
      based on the configured data management mode:</p>
<div class="itemizedlist"><ul class="itemizedlist" style="list-style-type: disc; ">
<li class="listitem"><p><span class="emphasis"><em>sharedfs</em></span> mode: the package is staged in
          to the shared filesystem once, and reused for all the jobs</p></li>
<li class="listitem"><p><span class="emphasis"><em>nonsharedfs</em></span> or
          <span class="emphasis"><em>condorio</em></span> mode: each job carries a worker
          package. This is obviously less efficient, but the size of the
          worker package is kept small to minimize the impact of these extra
          transfers.</p></li>
</ul></div>
<p>Which worker package is used is determined in the following
      order:</p>
<div class="itemizedlist"><ul class="itemizedlist" style="list-style-type: disc; ">
<li class="listitem"><p>There is an entry for pegasus::worker executable in the
          transformation catalog. Information on how to construct that entry
          is provided below.</p></li>
<li class="listitem"><p>The planner at runtime creates a worker package out of the
          binary installation, and puts it in the submit directory. This
          worker package is used if the OS and architecture of the created
          worker package match with remote site, or there is an exact match
          with (osrelease and osversion) if specified by the user in the site
          catalog for the remote site.</p></li>
<li class="listitem"><p>The worker package compatible with the remote site is
          available as a binary from the Pegasus download site.</p></li>
<li class="listitem"><p>At runtime, in the <span class="emphasis"><em>nonsharedfs</em></span> or
          <span class="emphasis"><em>condorio</em></span> modes, extra checks are made to make
          sure the worker package matches the Pegasus version and the OS and
          architecture. The reason is that these workflows might be running in
          an heterogeneous environment, and thus there is no way to know
          before the job starts what worker package is required. If the
          runtime check fails, a worker package matching the Pegasus version,
          OS and architecture will be downloaded from the Pegasus download
          site. This behavior can be controlled with the <a class="link" href="properties.php#pegasus.transfer.worker.package.autodownload">pegasus.transfer.worker.package.autodownload</a>
          and <a class="link" href="properties.php#pegasus.transfer.worker.package.strict">pegasus.transfer.worker.package.strict</a>
          properties.</p></li>
</ul></div>
<p>If you want to specify a particular worker package to use, you can
      specify the transformation <span class="bold"><strong>pegasus::worker</strong></span> in the transformation catalog
      with:</p>
<div class="itemizedlist"><ul class="itemizedlist" style="list-style-type: disc; ">
<li class="listitem"><p>type set to STAGEABLE</p></li>
<li class="listitem"><p>System Information attributes of the transformation catalog
          entry match the System Information attributes of the compute
          site.</p></li>
<li class="listitem"><p>the PFN specified should be a remote URL that can be pulled to
          the compute site.</p></li>
</ul></div>
<pre class="programlisting"># example of specifying a worker package in the transformation catalog
tr pegasus::worker {
site corbusier {
    pfn "https://download.pegasus.isi.edu/pegasus/4.8.0dev/pegasus-worker-4.8.0dev-x86_64_macos_10.tar.gz"
    arch "x86_64"
    os "MACOSX"
    type "INSTALLED"
  }
}
</pre>
</div>
<div class="section">
<div class="titlepage"><div><div><h3 class="title">
<a name="container-transfers"></a>10.2.8. Staging of Application Containers</h3></div></div></div>
<p>Pegasus treats containers as other files in terms of data
    management. Container to be used for a job is tracked as an input
    dependency that needs to be staged if it is not already there. Similar to
    executables, you specify the location for your container image in the
    Transformation Catalog. You can specify the source URL's for containers as
    the following.</p>
<div class="orderedlist"><ol class="orderedlist" type="1">
<li class="listitem">
<p>URL to a container hosted on a central hub repository</p>
<p>Example of a docker hub URL is docker:///rynge/montage:latest,
        while for singularity shub://pegasus-isi/fedora-montage</p>
</li>
<li class="listitem">
<p>URL to a container image file on a file server.</p>
<div class="itemizedlist"><ul class="itemizedlist" style="list-style-type: disc; ">
<li class="listitem"><p><span class="bold"><strong>Docker - </strong></span>Docker supports
            loading of containers from a tar file, Hence, containers images
            can only be specified as tar files and the extension for the
            filename is not important.</p></li>
<li class="listitem">
<p><span class="bold"><strong>Singularity -</strong></span> Singularity
            supports container images in various forms and relies on the
            extension in the filename to determine what format the file is in.
            Pegasus supports the following extensions for singularity
            container images</p>
<div class="itemizedlist"><ul class="itemizedlist" style="list-style-type: circle; ">
<li class="listitem"><p>.img</p></li>
<li class="listitem"><p>.tar</p></li>
<li class="listitem"><p>.tar.gz</p></li>
<li class="listitem"><p>.tar.bz2</p></li>
<li class="listitem"><p>.cpio</p></li>
<li class="listitem"><p>.cpio.gz</p></li>
<li class="listitem"><p>.sif</p></li>
</ul></div>
<p>Singularity will fail to run the container if you don't
            specify the right extension , when specify the source URL for the
            image.</p>
</li>
</ul></div>
</li>
</ol></div>
<p>In both the cases, Pegasus will place the container image on the
    staging site used for the workflow, as part of the data stage-in nodes,
    using pegasus-transfer. When pulling in an image from a container hub
    repository, pegasus-transfer will export the container as a tar file in
    case of Docker, and as .img file in case of Singularity</p>
<div class="section">
<div class="titlepage"><div><div><h4 class="title">
<a name="shifter_containers_staging"></a>10.2.8.1. Shifter Containers</h4></div></div></div>
<p>Shifter containers are different from docker and singularity with
      respect to the fact that the containers cannot be exported to a
      container image file that can reside on a filesystem. Additionally, the
      container are expected to be available locally on the compute sites in
      the local Shifter registry. Because of this, Pegasus does not do any
      transfer of Shifter containers. You can specify a shifter container
      using the shifter url scheme. For example, below is a transformation
      catalog for a namd transformation that is executed in a shifter
      container.</p>
<pre class="programlisting">cont namd_image{
     # can be either docker or singularity
     type "shifter"

     # image loaded in the local shifter repository at cori
     image "shifter:///papajim/namd_image:latest" 

     # optional site attribute to tell pegasus which site tar file
     # exists. useful for handling file URL's correctly
     image_site "cori"
}

tr namd2 {
    site cori {
        pfn "/opt/NAMD_2.12_Linux-x86_64-multicore/namd2"
        arch "x86_64"
        os "LINUX"
        type "INSTALLED"
        container "namd_image"
        profile globus "maxTime" "20"
        profile pegasus "exitcode.successmsg" "End of program"
    }
}</pre>
</div>
<div class="section">
<div class="titlepage"><div><div><h4 class="title">
<a name="container-symlinking"></a>10.2.8.2. Symlinking and File Copy From Host OS</h4></div></div></div>
<p>Since, Pegasus by default only mounts the job directory determined
      by PegasusLite into the application container, symlinking of input data
      sets works only if in the container definition in the transformation
      catalog user defines the directories containing the input data to be
      mounted in the container using the <span class="emphasis"><em><span class="bold"><strong>mount</strong></span></em></span> key word. We recommend to keep
      the source and destination directories to be the same i.e. the host path
      is mounted in the same location in the container.</p>
<p>The above is also true for the case, where you input datasets are
      on the shared filesystem on the compute site and you want a file copy to
      happen, when PegasusLite job starts the container.</p>
<p>For example in the example below, we have input datasets
      accessible on /lizard on the compute nodes, and mounting them as
      read-only into the container at /lizard</p>
<pre class="programlisting">cont centos-base{
     type "singularity"

     # URL to image in a docker hub or a url to an existing
     # singularity image file
     image "gsiftp://bamboo.isi.edu/lfs1/bamboo-tests/data/centos7.img"

     # optional site attribute to tell pegasus which site tar file
     # exists. useful for handling file URL's correctly
     image_site "local"

     # mount point in the container
     mount "/lizard:/lizard:ro"
  
     # specify env profile via env option do docker run
     profile env "JAVA_HOME" "/opt/java/1.6"	    
}</pre>
<p>To enable symlinking for containers set the following
      properties</p>
<pre class="programlisting"># Tells Pegasus to try and create symlinks for input files
pegasus.transfer.links true

# Tells Pegasus to by the staging site ( creation of stage-in jobs) as 
# data is available directly on compute nodes
pegasus.transfer.bypass.input.staging true

</pre>
<p>f you don't set pegasus.transfer.bypass.input.staging then you
      still can have symlinking if</p>
<div class="orderedlist"><ol class="orderedlist" type="1">
<li class="listitem"><p>your staging site is same as your compute site</p></li>
<li class="listitem"><p>the scratch directory specified in the site catalog is visible
          to the worker nodes</p></li>
<li class="listitem"><p>you mount the scratch directory in the container definition,
          NOT the original source directory.</p></li>
</ol></div>
<p>Enabling symlinking of containers is useful, when running large
      workflows on a single cluster. Pegasus can pull the image from the
      container repository once, and place it on the shared filesystem where
      it can then be symlinked from, when the PegasusLite jobs start on the
      worker nodes of that cluster. In order to do this, you need to be
      running the nonsharedfs data configuration mode with the staging site
      set to be the same as the compute site.</p>
</div>
</div>
<div class="section">
<div class="titlepage"><div><div><h3 class="title">
<a name="staging_job_checkpoint_files"></a>10.2.9. Staging of Job Checkpoint Files</h3></div></div></div>
<p>Pegasus has support for transferring job checkpoint files back to
      the staging site, when a job exceeds it's advertised running time. In
      order to use this feature, you need to</p>
<div class="orderedlist"><ol class="orderedlist" type="1">
<li class="listitem"><p>Associate a job checkpoint file ( that the job creates ) with
          the job in the DAX. A checkpoint file is specified by setting the
          link attribute to checkpoint for the uses tag.</p></li>
<li class="listitem"><p>Associate a Pegasus profile key named <span class="bold"><strong>
          checkpoint.time</strong></span> is the time in minutes after which a job
          is sent the TERM signal by pegasus-kickstart, telling it to create
          the checkpoint file.</p></li>
<li class="listitem"><p>Associate a Pegasus profile key named <span class="bold"><strong>
          maxwalltime</strong></span> with the job that specifies the max runtime
          in minutes before the job will be killed by the local resource
          manager ( such as PBS) deployed on the site. Usually, this value
          should be associated with the execution site in the site
          catalog.</p></li>
</ol></div>
<p>Pegasus planner uses the above mentioned profile keys to setup
      pegasus-kickstart such that the job is sent a TERM signal when the
      checkpoint time of job is reached. A KILL signal is sent at
      (checkpoint.time + (maxwalltime-checkpoint.time)/2) minutes. This
      ensures that there is enough time for pegasus-lite to transfer the
      checkpoint file before the job is killed by the underlying
      scheduler.</p>
</div>
</div><div class="navfooter">
<hr>
<table width="100%" summary="Navigation footer">
<tr>
<td width="40%" align="left">
<a accesskey="p" href="data_management.php">Prev</a> </td>
<td width="20%" align="center"><a accesskey="u" href="data_management.php">Up</a></td>
<td width="40%" align="right"> <a accesskey="n" href="transfer_protocols.php">Next</a>
</td>
</tr>
<tr>
<td width="40%" align="left" valign="top">Chapter 10. Data Management </td>
<td width="20%" align="center"><a accesskey="h" href="index.php">Table of Contents</a></td>
<td width="40%" align="right" valign="top"> 10.3. Supported Transfer Protocols</td>
</tr>
</table>
</div><?php  
            pegasus_footer();
        ?>
