<?php  
            require('/srv2/pegasus.isi.edu/includes/common.php'); 
            pegasus_header("10.3. Supported Transfer Protocols");
        ?><div class="breadcrumbs">
<span class="breadcrumb-link"><a href="index.php">Pegasus 4.9.3 User Guide</a></span> &gt; <span class="breadcrumb-link"><a href="data_management.php">Data Management</a></span> &gt; <span class="breadcrumb-node">Supported Transfer Protocols</span>
</div><hr><div class="section">
<div class="titlepage"><div><div><h2 class="title" style="clear: both">
<a name="transfer_protocols"></a>10.3. Supported Transfer Protocols</h2></div></div></div>
<div class="toc"><dl class="toc">
<dt><span class="section"><a href="transfer_protocols.php#transfer_s3">10.3.1. Amazon S3 (s3://)</a></span></dt>
<dt><span class="section"><a href="transfer_protocols.php#transfer_docker">10.3.2. Docker (docker://)</a></span></dt>
<dt><span class="section"><a href="transfer_protocols.php#transfer_singularity">10.3.3. Singularity (&lt;shub | library&gt;://)</a></span></dt>
<dt><span class="section"><a href="transfer_protocols.php#transfer_file">10.3.4. File / Symlink (file:// , symlink://)</a></span></dt>
<dt><span class="section"><a href="transfer_protocols.php#transfer_gridftp">10.3.5. GridFTP (gsiftp://)</a></span></dt>
<dt><span class="section"><a href="transfer_protocols.php#transfer_gridftp_ssh">10.3.6. GridFTP over SSH (sshftp://)</a></span></dt>
<dt><span class="section"><a href="transfer_protocols.php#transfer_google_storage">10.3.7. Google Storage (gs://)</a></span></dt>
<dt><span class="section"><a href="transfer_protocols.php#transfer_http">10.3.8. HTTP (http:// , https://)</a></span></dt>
<dt><span class="section"><a href="transfer_protocols.php#transfer_hpss">10.3.9. HPSS (hpss://)</a></span></dt>
<dt><span class="section"><a href="transfer_protocols.php#transfer_irods">10.3.10. iRODS (irods://)</a></span></dt>
<dt><span class="section"><a href="transfer_protocols.php#transfer_scp">10.3.11. SCP (scp://)</a></span></dt>
<dt><span class="section"><a href="transfer_protocols.php#transfer_stashcp">10.3.12. OSG Stash / stashcp (stash://)</a></span></dt>
<dt><span class="section"><a href="transfer_protocols.php#transfer_globus_online">10.3.13. Globus Online (go://)</a></span></dt>
</dl></div>
<p>Pegasus refers to a python script called <span class="bold"><strong>
    pegasus-transfer</strong></span> as the executable in the transfer jobs to
    transfer the data. pegasus-transfer looks at source and destination url
    and figures out automatically which underlying client to use.
    pegasus-transfer is distributed with the PEGASUS and can be found at
    $PEGASUS_HOME/bin/pegasus-transfer.</p>
<p>Currently, pegasus-transfer interfaces with the following transfer
    clients</p>
<div class="table">
<a name="idm5008"></a><p class="title"><b>Table 10.4. Transfer Clients interfaced to by pegasus-transfer</b></p>
<div class="table-contents"><table class="table" summary="Transfer Clients interfaced to by pegasus-transfer" border="1">
<colgroup>
<col>
<col>
</colgroup>
<thead><tr>
<th>Transfer Client</th>
<th>Used For</th>
</tr></thead>
<tbody>
<tr>
<td>gfal-copy</td>
<td>staging file to and from GridFTP servers</td>
</tr>
<tr>
<td>globus-url-copy</td>
<td>staging files to and from GridFTP servers, only if gfal is
            not detected in the path.</td>
</tr>
<tr>
<td>gfal-copy</td>
<td>staging files to and from SRM or XRootD servers</td>
</tr>
<tr>
<td>wget</td>
<td>staging files from a HTTP server</td>
</tr>
<tr>
<td>cp</td>
<td>copying files from a POSIX filesystem</td>
</tr>
<tr>
<td>ln</td>
<td>symlinking against input files</td>
</tr>
<tr>
<td>pegasus-s3</td>
<td>staging files to and from S3 buckets in Amazon Web
            Services</td>
</tr>
<tr>
<td>gsutil</td>
<td>staging files to and from Google Storage buckets</td>
</tr>
<tr>
<td>scp</td>
<td>staging files using scp</td>
</tr>
<tr>
<td>gsiscp</td>
<td>staging files using gsiscp and X509</td>
</tr>
<tr>
<td>iget</td>
<td>staging files to and from iRODS servers</td>
</tr>
<tr>
<td>htar</td>
<td>to retrieve input files from HPSS tape storage</td>
</tr>
<tr>
<td>docker</td>
<td>to pull images from Docker hub</td>
</tr>
<tr>
<td>singularity</td>
<td>to pull images from Singularity hub and Singularity library (Sylabs Cloud)</td>
</tr>
</tbody>
</table></div>
</div>
<br class="table-break"><p>For remote sites, Pegasus constructs the default path to
    pegasus-transfer on the basis of PEGASUS_HOME env profile specified in the
    site catalog. To specify a different path to the pegasus-transfer client ,
    users can add an entry into the transformation catalog with fully
    qualified logical name as <span class="bold"><strong>pegasus::pegasus-transfer</strong></span></p>
<div class="section">
<div class="titlepage"><div><div><h3 class="title">
<a name="transfer_s3"></a>10.3.1. Amazon S3 (s3://)</h3></div></div></div>
<p>Pegasus can be configured to use Amazon S3 as a staging site. In
      this mode, Pegasus transfers workflow inputs from the input site to S3.
      When a job runs, the inputs for that job are fetched from S3 to the
      worker node, the job is executed, then the output files are transferred
      from the worker node back to S3. When the jobs are complete, Pegasus
      transfers the output data from S3 to the output site.</p>
<p>In order to use S3, it is necessary to create a config file for
      the S3 transfer client, <a class="link" href="cli-pegasus-s3.php" title="pegasus-s3">
      pegasus-s3</a>. See the <a class="link" href="cli-pegasus-s3.php" title="pegasus-s3">man
      page</a> for details on how to create the config file. You also need
      to specify <a class="link" href="data_staging_configuration.php#non_shared_fs" title="5.3.2. Non Shared Filesystem">S3 as a staging
      site</a>.</p>
<p>Next, you need to modify your site catalog to tell the location of
      your s3cfg file. See <a class="link" href="cred_staging.php" title="10.4. Credentials Management">the section on
      credential staging</a>.</p>
<p>The following site catalog shows how to specify the location of
      the s3cfg file on the local site and how to specify an Amazon S3 staging
      site:</p>
<pre class="programlisting">&lt;sitecatalog xmlns="http://pegasus.isi.edu/schema/sitecatalog"
             xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
             xsi:schemaLocation="http://pegasus.isi.edu/schema/sitecatalog
             http://pegasus.isi.edu/schema/sc-3.0.xsd" version="3.0"&gt;
    &lt;site handle="local" arch="x86_64" os="LINUX"&gt;
        &lt;head-fs&gt;
            &lt;scratch&gt;
                &lt;shared&gt;
                    &lt;file-server protocol="file" url="file://" mount-point="/tmp/wf/work"/&gt;
                    &lt;internal-mount-point mount-point="/tmp/wf/work"/&gt;
                &lt;/shared&gt;
            &lt;/scratch&gt;
            &lt;storage&gt;
                &lt;shared&gt;
                    &lt;file-server protocol="file" url="file://" mount-point="/tmp/wf/storage"/&gt;
                    &lt;internal-mount-point mount-point="/tmp/wf/storage"/&gt;
                &lt;/shared&gt;
            &lt;/storage&gt;
        &lt;/head-fs&gt;
        <span class="bold"><strong>&lt;profile namespace="env" key="S3CFG"&gt;/home/username/.s3cfg&lt;/profile&gt;</strong></span>
    &lt;/site&gt;
    <span class="bold"><strong>&lt;site handle="s3" arch="x86_64" os="LINUX"&gt;
        &lt;head-fs&gt;
            &lt;scratch&gt;
                &lt;shared&gt;
                    &lt;!-- wf-scratch is the name of the S3 bucket that will be used --&gt;
                    &lt;file-server protocol="s3" url="s3://user@amazon" mount-point="/wf-scratch"/&gt;
                    &lt;internal-mount-point mount-point="/wf-scratch"/&gt;
                &lt;/shared&gt;
            &lt;/scratch&gt;
        &lt;/head-fs&gt;
    &lt;/site&gt;</strong></span>
    &lt;site handle="condorpool" arch="x86_64" os="LINUX"&gt;
        &lt;head-fs&gt;
            &lt;scratch/&gt;
            &lt;storage/&gt;
        &lt;/head-fs&gt;
        &lt;profile namespace="pegasus" key="style"&gt;condor&lt;/profile&gt;
        &lt;profile namespace="condor" key="universe"&gt;vanilla&lt;/profile&gt;
        &lt;profile namespace="condor" key="requirements"&gt;(Target.Arch == "X86_64")&lt;/profile&gt;
    &lt;/site&gt;
&lt;/sitecatalog&gt;
</pre>
</div>
<div class="section">
<div class="titlepage"><div><div><h3 class="title">
<a name="transfer_docker"></a>10.3.2. Docker (docker://)</h3></div></div></div>
<p>Container images can be pulled directly from Docker Hub using Docker URLs.
            Example: docker://pegasus/osg-el7
      </p>
<p>Example: docker://pegasus/osg-el7
      </p>
<p>Only public images are supported at this time.
      </p>
</div>
<div class="section">
<div class="titlepage"><div><div><h3 class="title">
<a name="transfer_singularity"></a>10.3.3. Singularity (&lt;shub | library&gt;://)</h3></div></div></div>
<p>Container images can be pulled directly from Singularity hub and
          Singularity library depending on the version of Singularity installed
          on a node requiring the container image. Singularity hub images require
          at least Singularity v2.3, while Singularity library images require
          at least Singularity v3.0. 
        </p>
<p>Example: shub://vsoch/singularity-images
        </p>
<p>Example: library://sylabsed/examples/lolcow
        </p>
<p>Only public images are supported at this time.
        </p>
</div>
<div class="section">
<div class="titlepage"><div><div><h3 class="title">
<a name="transfer_file"></a>10.3.4. File / Symlink (file:// , symlink://)</h3></div></div></div>
<p></p>
</div>
<div class="section">
<div class="titlepage"><div><div><h3 class="title">
<a name="transfer_gridftp"></a>10.3.5. GridFTP (gsiftp://)</h3></div></div></div>
<p></p>
<div class="section">
<div class="titlepage"><div><div><h4 class="title">
<a name="idm5090"></a>10.3.5.1. Preference of GFAL over GUC</h4></div></div></div>
<p>JGlobus is no longer actively supported and is not in compliance
        with <a class="ulink" href="https://docs.globus.org/security-bulletins/2015-12-strict-mode" target="_top">RFC
        2818</a> . As a result cleanup jobs using pegasus-gridftp client
        would fail against the servers supporting the strict mode. We have
        removed the pegasus-gridftp client and now use gfal clients as
        globus-url-copy does not support removes. If gfal is not available,
        globus-url-copy is used for cleanup by writing out zero bytes files
        instead of removing them.</p>
<p>If you want to force globus-url-copy to be preferred over GFAL,
        set the <span class="bold"><strong>PEGASUS_FORCE_GUC=1</strong></span>
        environment variable in the site catalog for the sites you want the
        preference to be enforced. Please note that we expect globus-url-copy
        support to be completely removed in future releases of Pegasus due to
        the end of life of Globus Toolkit (see <a class="ulink" href="https://www.globus.org/blog/support-open-source-globus-toolkit-ends-january-2018" target="_top">announcement</a>).</p>
</div>
</div>
<div class="section">
<div class="titlepage"><div><div><h3 class="title">
<a name="transfer_gridftp_ssh"></a>10.3.6. GridFTP over SSH (sshftp://)</h3></div></div></div>
<p>Instead of using X.509 based security, newer version of Globus
      GridFTP can be configured to set up transfers over SSH. See the <a class="ulink" href="http://toolkit.globus.org/toolkit/docs/6.0/gridftp/admin/#gridftp-admin-config-security-sshftp" target="_top">Globus
      Documentation</a> for details on installing and setting up this
      feature.</p>
<p>Pegasus requires the ability to specify which SSH key to be used
      at runtime, and thus a small modification is necessary to the default
      Globus configuration. On the hosts where Pegasus initiates transfers
      (which depends on the data configuration of the workflow), please
      replace <span class="emphasis"><em>gridftp-ssh</em></span>, usually located under
      <span class="emphasis"><em>/usr/share/globus/gridftp-ssh</em></span>, with:</p>
<pre class="programlisting">
#!/bin/bash

url_string=$1
remote_host=$2
port=$3
user=$4

port_str=""
if  [ "X" = "X$port" ]; then
    port_str=""
else
    port_str=" -p $port "
fi

if  [ "X" != "X$user" ]; then
    remote_host="$user@$remote_host"
fi

remote_default1=.globus/sshftp
remote_default2=/etc/grid-security/sshftp
remote_fail="echo -e 500 Server is not configured for SSHFTP connections.\\\r\\\n"
remote_program=$GLOBUS_REMOTE_SSHFTP
if  [ "X" = "X$remote_program" ]; then
    remote_program="(( test -f $remote_default1 &amp;&amp; $remote_default1 ) || ( test -f $remote_default2 &amp;&amp; $remote_default2 ) || $remote_fail )"
fi

if [ "X" != "X$GLOBUS_SSHFTP_PRINT_ON_CONNECT" ]; then
    echo "Connecting to $1 ..." &gt;/dev/tty
fi

# for pegasus-transfer
extra_opts=" -o StrictHostKeyChecking=no"
if [ "x$SSH_PRIVATE_KEY" != "x" ]; then
    extra_opts="$extra_opts -i $SSH_PRIVATE_KEY"
fi

exec /usr/bin/ssh $extra_opts $port_str $remote_host $remote_program
</pre>
<p>Once configured, you should be able to use URLs such as
      <span class="emphasis"><em>sshftp://username@host/foo/bar.txt</em></span> in your
      workflows.</p>
</div>
<div class="section">
<div class="titlepage"><div><div><h3 class="title">
<a name="transfer_google_storage"></a>10.3.7. Google Storage (gs://)</h3></div></div></div>
<p></p>
</div>
<div class="section">
<div class="titlepage"><div><div><h3 class="title">
<a name="transfer_http"></a>10.3.8. HTTP (http:// , https://)</h3></div></div></div>
<p></p>
</div>
<div class="section">
<div class="titlepage"><div><div><h3 class="title">
<a name="transfer_hpss"></a>10.3.9. HPSS (hpss://)</h3></div></div></div>
<p>We support retrieval of input files from a tar file in HPSS
      storage using the htar command. The naming convention to describe the
      tar file and the file to retrieve fro the tar file is as follows</p>
<pre class="programlisting">hpss:///some-name.tar/path/in-tar-to/file.txt</pre>
<p>For example: for e.g hpss:///test.tar/set1/f.a </p>
<p>For efficient retrieval pegasus-transfer bin's all the hpss
      transfers in the .in file </p>
<div class="itemizedlist"><ul class="itemizedlist" style="list-style-type: disc; ">
<li class="listitem"><p>fiirst by the tar file and then</p></li>
<li class="listitem"><p>the destination directory.</p></li>
</ul></div>
<p>Binning by destination directory is done to support deep LFN's.
      Also thing to note is that htar command returns success even if a file
      does not exist in the archive. pegasus-transfer tries to make sure after
      the transfer that the destination file exists and is readable.</p>
<p>HPSS requires a token to generated for retrieval. Information on
      how to specify the token location can be found <a class="link" href="cred_staging.php#hpss_cred" title="10.4.6. HPSS Tokens">here</a>.</p>
</div>
<div class="section">
<div class="titlepage"><div><div><h3 class="title">
<a name="transfer_irods"></a>10.3.10. iRODS (irods://)</h3></div></div></div>
<p>iRODS can be used as a input data location, a storage site for
      intermediate data during workflow execution, or a location for final
      output data. Pegasus uses a URL notation to identify iRODS files.
      Example:</p>
<pre class="programlisting">irods://some-host.org/path/to/file.txt</pre>
<p>The path to the file is <span class="bold"><strong> relative</strong></span>
      to the internal iRODS location. In the example above, the path used to
      refer to the file in iRODS is <span class="emphasis"><em> path/to/file.txt</em></span> (no
      leading /).</p>
<p>See <a class="link" href="cred_staging.php" title="10.4. Credentials Management">the section on credential
      staging</a> for information on how to set up an irodsEnv file to be
      used by Pegasus.</p>
</div>
<div class="section">
<div class="titlepage"><div><div><h3 class="title">
<a name="transfer_scp"></a>10.3.11. SCP (scp://)</h3></div></div></div>
<p></p>
</div>
<div class="section">
<div class="titlepage"><div><div><h3 class="title">
<a name="transfer_stashcp"></a>10.3.12. OSG Stash / stashcp (stash://)</h3></div></div></div>
<p>Open Science Grid provides a data service called Stash, and the
      command line tool <span class="emphasis"><em>stashcp</em></span> for interacting with the
      Stash data. An example on how to set up the site catalog and URLs can be
      found in the <a class="ulink" href="https://support.opensciencegrid.org/support/solutions/articles/5000639789-pegasus" target="_top">OSG
      User Support Pegasus tutorial</a></p>
</div>
<div class="section">
<div class="titlepage"><div><div><h3 class="title">
<a name="transfer_globus_online"></a>10.3.13. Globus Online (go://)</h3></div></div></div>
<p><a class="ulink" href="http://globus.org" target="_top">Globus Online</a> is a transfer
      service with features such as policy based connection management and
      automatic failure detection and recovery. Pegasus has limited the
      support for Globus Online transfers.</p>
<p>If you want to use Globus Online in your workflow, all data has to
      be accessible via a Globus Online endpoint. You can not mix Globus
      Online endpoints with other protocols. For most users, this means they
      will have to create an endpoint for their submit host and probably
      modify both the replica catalog and DAX generator so that all URLs in
      the workflow are for Globus Online endpoints.</p>
<p>There are two levels of credentials required. One is for the
      workflow to use the Globus Online API, which is handled by OAuth tokens,
      provided by Globus Auth service. The second level is for the endpoints,
      which the user will have to manage via the Globus Online web interface.
      The required steps are:</p>
<div class="orderedlist"><ol class="orderedlist" type="1">
<li class="listitem"><p>Using <span class="emphasis"><em>pegasus-globus-online-init</em></span>, provide
          authorization to Pegasus and retrieve your transfer access tokens.
          By default Pegasus acquires temporary tokens that expire within a
          few days. Using --permanent option you can request refreshable
          tokens that last indefinetely (or until access is revoked).</p></li>
<li class="listitem"><p>In the Globus Online web interface, under Endpoints, find the
          endpoints you need for the workflow, and activate them. Note that
          you should activate them for the whole duration of the workflow or
          you will have to regularly log in and re-activate the endpoints
          during workflow execution.</p></li>
</ol></div>
<p>URLs for Globus Online endpoint data follows the following scheme:
      <span class="emphasis"><em>go://[endpoint]/[path]</em></span>. For example, for a user
      with the Globus Online private endpoint
      <span class="emphasis"><em>bob#researchdata</em></span> and a file
      <span class="emphasis"><em>/home/bsmith/experiment/1.dat</em></span>, the URL would be:
      <span class="emphasis"><em>go://bob#researchdata/home/bsmith/experiment/1.dat</em></span></p>
</div>
</div><div class="navfooter">
<hr>
<table width="100%" summary="Navigation footer">
<tr>
<td width="40%" align="left">
<a accesskey="p" href="transfer.php">Prev</a> </td>
<td width="20%" align="center"><a accesskey="u" href="data_management.php">Up</a></td>
<td width="40%" align="right"> <a accesskey="n" href="cred_staging.php">Next</a>
</td>
</tr>
<tr>
<td width="40%" align="left" valign="top">10.2. Data Transfers </td>
<td width="20%" align="center"><a accesskey="h" href="index.php">Table of Contents</a></td>
<td width="40%" align="right" valign="top"> 10.4. Credentials Management</td>
</tr>
</table>
</div><?php  
            pegasus_footer();
        ?>
